# This file was autogenerated by some hot garbage in the `uniffi` crate.
# Trust me, you don't want to mess with it!

# Common helper code.
#
# Ideally this would live in a separate .py file where it can be unittested etc
# in isolation, and perhaps even published as a re-useable package.
#
# However, it's important that the details of how this helper code works (e.g. the
# way that different builtin types are passed across the FFI) exactly match what's
# expected by the rust code on the other side of the interface. In practice right
# now that means coming from the exact some version of `uniffi` that was used to
# compile the rust component. The easiest way to ensure this is to bundle the Python
# helpers directly inline like we're doing here.

import os
import sys
import ctypes
import enum
import struct
import contextlib
import datetime
import typing
import platform

# Used for default argument values
_DEFAULT = object()


class _UniffiRustBuffer(ctypes.Structure):
    _fields_ = [
        ("capacity", ctypes.c_int32),
        ("len", ctypes.c_int32),
        ("data", ctypes.POINTER(ctypes.c_char)),
    ]

    @staticmethod
    def alloc(size):
        return _rust_call(_UniffiLib.ffi_iroh_rustbuffer_alloc, size)

    @staticmethod
    def reserve(rbuf, additional):
        return _rust_call(_UniffiLib.ffi_iroh_rustbuffer_reserve, rbuf, additional)

    def free(self):
        return _rust_call(_UniffiLib.ffi_iroh_rustbuffer_free, self)

    def __str__(self):
        return "_UniffiRustBuffer(capacity={}, len={}, data={})".format(
            self.capacity,
            self.len,
            self.data[0:self.len]
        )

    @contextlib.contextmanager
    def alloc_with_builder(*args):
        """Context-manger to allocate a buffer using a _UniffiRustBufferBuilder.

        The allocated buffer will be automatically freed if an error occurs, ensuring that
        we don't accidentally leak it.
        """
        builder = _UniffiRustBufferBuilder()
        try:
            yield builder
        except:
            builder.discard()
            raise

    @contextlib.contextmanager
    def consume_with_stream(self):
        """Context-manager to consume a buffer using a _UniffiRustBufferStream.

        The _UniffiRustBuffer will be freed once the context-manager exits, ensuring that we don't
        leak it even if an error occurs.
        """
        try:
            s = _UniffiRustBufferStream.from_rust_buffer(self)
            yield s
            if s.remaining() != 0:
                raise RuntimeError("junk data left in buffer at end of consume_with_stream")
        finally:
            self.free()

    @contextlib.contextmanager
    def read_with_stream(self):
        """Context-manager to read a buffer using a _UniffiRustBufferStream.

        This is like consume_with_stream, but doesn't free the buffer afterwards.
        It should only be used with borrowed `_UniffiRustBuffer` data.
        """
        s = _UniffiRustBufferStream.from_rust_buffer(self)
        yield s
        if s.remaining() != 0:
            raise RuntimeError("junk data left in buffer at end of read_with_stream")

class _UniffiForeignBytes(ctypes.Structure):
    _fields_ = [
        ("len", ctypes.c_int32),
        ("data", ctypes.POINTER(ctypes.c_char)),
    ]

    def __str__(self):
        return "_UniffiForeignBytes(len={}, data={})".format(self.len, self.data[0:self.len])


class _UniffiRustBufferStream:
    """
    Helper for structured reading of bytes from a _UniffiRustBuffer
    """

    def __init__(self, data, len):
        self.data = data
        self.len = len
        self.offset = 0

    @classmethod
    def from_rust_buffer(cls, buf):
        return cls(buf.data, buf.len)

    def remaining(self):
        return self.len - self.offset

    def _unpack_from(self, size, format):
        if self.offset + size > self.len:
            raise InternalError("read past end of rust buffer")
        value = struct.unpack(format, self.data[self.offset:self.offset+size])[0]
        self.offset += size
        return value

    def read(self, size):
        if self.offset + size > self.len:
            raise InternalError("read past end of rust buffer")
        data = self.data[self.offset:self.offset+size]
        self.offset += size
        return data

    def read_i8(self):
        return self._unpack_from(1, ">b")

    def read_u8(self):
        return self._unpack_from(1, ">B")

    def read_i16(self):
        return self._unpack_from(2, ">h")

    def read_u16(self):
        return self._unpack_from(2, ">H")

    def read_i32(self):
        return self._unpack_from(4, ">i")

    def read_u32(self):
        return self._unpack_from(4, ">I")

    def read_i64(self):
        return self._unpack_from(8, ">q")

    def read_u64(self):
        return self._unpack_from(8, ">Q")

    def read_float(self):
        v = self._unpack_from(4, ">f")
        return v

    def read_double(self):
        return self._unpack_from(8, ">d")

    def read_c_size_t(self):
        return self._unpack_from(ctypes.sizeof(ctypes.c_size_t) , "@N")

class _UniffiRustBufferBuilder:
    """
    Helper for structured writing of bytes into a _UniffiRustBuffer.
    """

    def __init__(self):
        self.rbuf = _UniffiRustBuffer.alloc(16)
        self.rbuf.len = 0

    def finalize(self):
        rbuf = self.rbuf
        self.rbuf = None
        return rbuf

    def discard(self):
        if self.rbuf is not None:
            rbuf = self.finalize()
            rbuf.free()

    @contextlib.contextmanager
    def _reserve(self, num_bytes):
        if self.rbuf.len + num_bytes > self.rbuf.capacity:
            self.rbuf = _UniffiRustBuffer.reserve(self.rbuf, num_bytes)
        yield None
        self.rbuf.len += num_bytes

    def _pack_into(self, size, format, value):
        with self._reserve(size):
            # XXX TODO: I feel like I should be able to use `struct.pack_into` here but can't figure it out.
            for i, byte in enumerate(struct.pack(format, value)):
                self.rbuf.data[self.rbuf.len + i] = byte

    def write(self, value):
        with self._reserve(len(value)):
            for i, byte in enumerate(value):
                self.rbuf.data[self.rbuf.len + i] = byte

    def write_i8(self, v):
        self._pack_into(1, ">b", v)

    def write_u8(self, v):
        self._pack_into(1, ">B", v)

    def write_i16(self, v):
        self._pack_into(2, ">h", v)

    def write_u16(self, v):
        self._pack_into(2, ">H", v)

    def write_i32(self, v):
        self._pack_into(4, ">i", v)

    def write_u32(self, v):
        self._pack_into(4, ">I", v)

    def write_i64(self, v):
        self._pack_into(8, ">q", v)

    def write_u64(self, v):
        self._pack_into(8, ">Q", v)

    def write_float(self, v):
        self._pack_into(4, ">f", v)

    def write_double(self, v):
        self._pack_into(8, ">d", v)

    def write_c_size_t(self, v):
        self._pack_into(ctypes.sizeof(ctypes.c_size_t) , "@N", v)
# A handful of classes and functions to support the generated data structures.
# This would be a good candidate for isolating in its own ffi-support lib.

class InternalError(Exception):
    pass

class _UniffiRustCallStatus(ctypes.Structure):
    """
    Error runtime.
    """
    _fields_ = [
        ("code", ctypes.c_int8),
        ("error_buf", _UniffiRustBuffer),
    ]

    # These match the values from the uniffi::rustcalls module
    CALL_SUCCESS = 0
    CALL_ERROR = 1
    CALL_PANIC = 2

    def __str__(self):
        if self.code == _UniffiRustCallStatus.CALL_SUCCESS:
            return "_UniffiRustCallStatus(CALL_SUCCESS)"
        elif self.code == _UniffiRustCallStatus.CALL_ERROR:
            return "_UniffiRustCallStatus(CALL_ERROR)"
        elif self.code == _UniffiRustCallStatus.CALL_PANIC:
            return "_UniffiRustCallStatus(CALL_PANIC)"
        else:
            return "_UniffiRustCallStatus(<invalid code>)"

def _rust_call(fn, *args):
    # Call a rust function
    return _rust_call_with_error(None, fn, *args)

def _rust_call_with_error(error_ffi_converter, fn, *args):
    # Call a rust function and handle any errors
    #
    # This function is used for rust calls that return Result<> and therefore can set the CALL_ERROR status code.
    # error_ffi_converter must be set to the _UniffiConverter for the error class that corresponds to the result.
    call_status = _UniffiRustCallStatus(code=_UniffiRustCallStatus.CALL_SUCCESS, error_buf=_UniffiRustBuffer(0, 0, None))

    args_with_error = args + (ctypes.byref(call_status),)
    result = fn(*args_with_error)
    _uniffi_check_call_status(error_ffi_converter, call_status)
    return result

def _rust_call_async(scaffolding_fn, callback_fn, *args):
    # Call the scaffolding function, passing it a callback handler for `AsyncTypes.py` and a pointer
    # to a python Future object.  The async function then awaits the Future.
    uniffi_eventloop = asyncio.get_running_loop()
    uniffi_py_future = uniffi_eventloop.create_future()
    uniffi_call_status = _UniffiRustCallStatus(code=_UniffiRustCallStatus.CALL_SUCCESS, error_buf=_UniffiRustBuffer(0, 0, None))
    scaffolding_fn(*args,
       _UniffiConverterForeignExecutor._pointer_manager.new_pointer(uniffi_eventloop),
       callback_fn,
       # Note: It's tempting to skip the pointer manager and just use a `py_object` pointing to a
       # local variable like we do in Swift.  However, Python doesn't use cooperative cancellation
       # -- asyncio can cancel a task at anytime.  This means if we use a local variable, the Rust
       # callback could fire with a dangling pointer.
       _UniffiPyFuturePointerManager.new_pointer(uniffi_py_future),
       ctypes.byref(uniffi_call_status),
    )
    _uniffi_check_call_status(None, uniffi_call_status)
    return uniffi_py_future

def _uniffi_check_call_status(error_ffi_converter, call_status):
    if call_status.code == _UniffiRustCallStatus.CALL_SUCCESS:
        pass
    elif call_status.code == _UniffiRustCallStatus.CALL_ERROR:
        if error_ffi_converter is None:
            call_status.error_buf.free()
            raise InternalError("_rust_call_with_error: CALL_ERROR, but error_ffi_converter is None")
        else:
            raise error_ffi_converter.lift(call_status.error_buf)
    elif call_status.code == _UniffiRustCallStatus.CALL_PANIC:
        # When the rust code sees a panic, it tries to construct a _UniffiRustBuffer
        # with the message.  But if that code panics, then it just sends back
        # an empty buffer.
        if call_status.error_buf.len > 0:
            msg = _UniffiConverterString.lift(call_status.error_buf)
        else:
            msg = "Unknown rust panic"
        raise InternalError(msg)
    else:
        raise InternalError("Invalid _UniffiRustCallStatus code: {}".format(
            call_status.code))

# A function pointer for a callback as defined by UniFFI.
# Rust definition `fn(handle: u64, method: u32, args: _UniffiRustBuffer, buf_ptr: *mut _UniffiRustBuffer) -> int`
_UNIFFI_FOREIGN_CALLBACK_T = ctypes.CFUNCTYPE(ctypes.c_int, ctypes.c_ulonglong, ctypes.c_ulong, ctypes.POINTER(ctypes.c_char), ctypes.c_int, ctypes.POINTER(_UniffiRustBuffer))
class _UniffiPointerManagerCPython:
    """
    Manage giving out pointers to Python objects on CPython

    This class is used to generate opaque pointers that reference Python objects to pass to Rust.
    It assumes a CPython platform.  See _UniffiPointerManagerGeneral for the alternative.
    """

    def new_pointer(self, obj):
        """
        Get a pointer for an object as a ctypes.c_size_t instance

        Each call to new_pointer() must be balanced with exactly one call to release_pointer()

        This returns a ctypes.c_size_t.  This is always the same size as a pointer and can be
        interchanged with pointers for FFI function arguments and return values.
        """
        # IncRef the object since we're going to pass a pointer to Rust
        ctypes.pythonapi.Py_IncRef(ctypes.py_object(obj))
        # id() is the object address on CPython
        # (https://docs.python.org/3/library/functions.html#id)
        return id(obj)

    def release_pointer(self, address):
        py_obj = ctypes.cast(address, ctypes.py_object)
        obj = py_obj.value
        ctypes.pythonapi.Py_DecRef(py_obj)
        return obj

    def lookup(self, address):
        return ctypes.cast(address, ctypes.py_object).value

class _UniffiPointerManagerGeneral:
    """
    Manage giving out pointers to Python objects on non-CPython platforms

    This has the same API as _UniffiPointerManagerCPython, but doesn't assume we're running on
    CPython and is slightly slower.

    Instead of using real pointers, it maps integer values to objects and returns the keys as
    c_size_t values.
    """

    def __init__(self):
        self._map = {}
        self._lock = threading.Lock()
        self._current_handle = 0

    def new_pointer(self, obj):
        with self._lock:
            handle = self._current_handle
            self._current_handle += 1
            self._map[handle] = obj
        return handle

    def release_pointer(self, handle):
        with self._lock:
            return self._map.pop(handle)

    def lookup(self, handle):
        with self._lock:
            return self._map[handle]

# Pick an pointer manager implementation based on the platform
if platform.python_implementation() == 'CPython':
    _UniffiPointerManager = _UniffiPointerManagerCPython # type: ignore
else:
    _UniffiPointerManager = _UniffiPointerManagerGeneral # type: ignore
# Types conforming to `_UniffiConverterPrimitive` pass themselves directly over the FFI.
class _UniffiConverterPrimitive:
    @classmethod
    def check(cls, value):
        return value

    @classmethod
    def lift(cls, value):
        return value

    @classmethod
    def lower(cls, value):
        return cls.lowerUnchecked(cls.check(value))

    @classmethod
    def lowerUnchecked(cls, value):
        return value

    @classmethod
    def write(cls, value, buf):
        cls.write_unchecked(cls.check(value), buf)

class _UniffiConverterPrimitiveInt(_UniffiConverterPrimitive):
    @classmethod
    def check(cls, value):
        try:
            value = value.__index__()
        except Exception:
            raise TypeError("'{}' object cannot be interpreted as an integer".format(type(value).__name__))
        if not isinstance(value, int):
            raise TypeError("__index__ returned non-int (type {})".format(type(value).__name__))
        if not cls.VALUE_MIN <= value < cls.VALUE_MAX:
            raise ValueError("{} requires {} <= value < {}".format(cls.CLASS_NAME, cls.VALUE_MIN, cls.VALUE_MAX))
        return super().check(value)

class _UniffiConverterPrimitiveFloat(_UniffiConverterPrimitive):
    @classmethod
    def check(cls, value):
        try:
            value = value.__float__()
        except Exception:
            raise TypeError("must be real number, not {}".format(type(value).__name__))
        if not isinstance(value, float):
            raise TypeError("__float__ returned non-float (type {})".format(type(value).__name__))
        return super().check(value)

# Helper class for wrapper types that will always go through a _UniffiRustBuffer.
# Classes should inherit from this and implement the `read` and `write` static methods.
class _UniffiConverterRustBuffer:
    @classmethod
    def lift(cls, rbuf):
        with rbuf.consume_with_stream() as stream:
            return cls.read(stream)

    @classmethod
    def lower(cls, value):
        with _UniffiRustBuffer.alloc_with_builder() as builder:
            cls.write(value, builder)
            return builder.finalize()

# Contains loading, initialization code, and the FFI Function declarations.
# Define some ctypes FFI types that we use in the library

"""
ctypes type for the foreign executor callback.  This is a built-in interface for scheduling
tasks

Args:
  executor: opaque c_size_t value representing the eventloop
  delay: delay in ms
  task: function pointer to the task callback
  task_data: void pointer to the task callback data

Normally we should call task(task_data) after the detail.
However, when task is NULL this indicates that Rust has dropped the ForeignExecutor and we should
decrease the EventLoop refcount.
"""
_UNIFFI_FOREIGN_EXECUTOR_CALLBACK_T = ctypes.CFUNCTYPE(ctypes.c_int8, ctypes.c_size_t, ctypes.c_uint32, ctypes.c_void_p, ctypes.c_void_p)

"""
Function pointer for a Rust task, which a callback function that takes a opaque pointer
"""
_UNIFFI_RUST_TASK = ctypes.CFUNCTYPE(None, ctypes.c_void_p, ctypes.c_int8)

def _uniffi_future_callback_t(return_type):
    """
    Factory function to create callback function types for async functions
    """
    return ctypes.CFUNCTYPE(None, ctypes.c_size_t, return_type, _UniffiRustCallStatus)

def _uniffi_load_indirect():
    """
    This is how we find and load the dynamic library provided by the component.
    For now we just look it up by name.
    """
    if sys.platform == "darwin":
        libname = "lib{}.dylib"
    elif sys.platform.startswith("win"):
        # As of python3.8, ctypes does not seem to search $PATH when loading DLLs.
        # We could use `os.add_dll_directory` to configure the search path, but
        # it doesn't feel right to mess with application-wide settings. Let's
        # assume that the `.dll` is next to the `.py` file and load by full path.
        libname = os.path.join(
            os.path.dirname(__file__),
            "{}.dll",
        )
    else:
        # Anything else must be an ELF platform - Linux, *BSD, Solaris/illumos
        libname = "lib{}.so"

    libname = libname.format("uniffi_iroh")
    path = os.path.join(os.path.dirname(__file__), libname)
    lib = ctypes.cdll.LoadLibrary(path)
    return lib

def _uniffi_check_contract_api_version(lib):
    # Get the bindings contract version from our ComponentInterface
    bindings_contract_version = 23
    # Get the scaffolding contract version by calling the into the dylib
    scaffolding_contract_version = lib.ffi_iroh_uniffi_contract_version()
    if bindings_contract_version != scaffolding_contract_version:
        raise InternalError("UniFFI contract version mismatch: try cleaning and rebuilding your project")

def _uniffi_check_api_checksums(lib):
    if lib.uniffi_iroh_checksum_func_key_to_path() != 1201:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_func_path_to_key() != 27769:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_func_set_log_level() != 52296:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_func_start_metrics_collection() != 17691:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_addprogress_as_abort() != 64540:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_addprogress_as_all_done() != 24629:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_addprogress_as_done() != 65369:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_addprogress_as_found() != 14508:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_addprogress_as_progress() != 54075:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_addprogress_type() != 63416:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_authorid_equal() != 33867:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_authorid_to_string() != 42389:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_doc_close() != 23013:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_doc_del() != 22285:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_doc_export_file() != 34185:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_doc_get_many() != 58857:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_doc_get_one() != 25151:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_doc_id() != 34677:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_doc_import_file() != 33349:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_doc_leave() != 55816:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_doc_read_to_bytes() != 37830:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_doc_set_bytes() != 15024:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_doc_set_hash() != 20311:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_doc_share() != 28913:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_doc_size() != 27875:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_doc_start_sync() != 54158:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_doc_status() != 59550:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_doc_subscribe() != 2866:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_docexportprogress_as_abort() != 39226:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_docexportprogress_as_found() != 11254:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_docexportprogress_as_progress() != 8859:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_docexportprogress_type() != 43844:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_docimportprogress_as_abort() != 45779:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_docimportprogress_as_all_done() != 7478:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_docimportprogress_as_found() != 55008:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_docimportprogress_as_ingest_done() != 37186:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_docimportprogress_as_progress() != 35401:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_docimportprogress_type() != 49227:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_docticket_equal() != 14909:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_docticket_to_string() != 22814:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_downloadprogress_as_abort() != 13741:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_downloadprogress_as_done() != 54270:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_downloadprogress_as_export() != 48739:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_downloadprogress_as_export_progress() != 42097:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_downloadprogress_as_found() != 13482:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_downloadprogress_as_found_hash_seq() != 64232:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_downloadprogress_as_network_done() != 49397:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_downloadprogress_as_progress() != 7204:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_downloadprogress_type() != 8349:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_entry_author() != 26124:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_entry_content_hash() != 39306:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_entry_content_len() != 60107:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_entry_key() != 19122:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_entry_namespace() != 41306:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_hash_as_cid_bytes() != 25019:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_hash_equal() != 65301:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_hash_to_bytes() != 29465:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_hash_to_hex() != 27622:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_hash_to_string() != 61408:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_ipv4addr_equal() != 51523:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_ipv4addr_octets() != 17752:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_ipv4addr_to_string() != 5658:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_ipv6addr_equal() != 26037:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_ipv6addr_segments() != 41182:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_ipv6addr_to_string() != 46637:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_irohnode_author_create() != 31148:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_irohnode_author_list() != 12499:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_irohnode_blobs_add_bytes() != 20668:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_irohnode_blobs_add_from_path() != 38440:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_irohnode_blobs_delete_blob() != 24766:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_irohnode_blobs_download() != 50921:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_irohnode_blobs_list() != 49039:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_irohnode_blobs_list_collections() != 28497:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_irohnode_blobs_list_incomplete() != 39285:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_irohnode_blobs_read_to_bytes() != 6512:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_irohnode_blobs_size() != 52941:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_irohnode_blobs_write_to_path() != 9029:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_irohnode_connection_info() != 39895:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_irohnode_connections() != 37352:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_irohnode_doc_create() != 64213:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_irohnode_doc_join() != 30773:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_irohnode_doc_list() != 44252:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_irohnode_node_id() != 31962:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_irohnode_stats() != 16158:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_liveevent_as_content_ready() != 15237:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_liveevent_as_insert_local() != 431:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_liveevent_as_insert_remote() != 17302:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_liveevent_as_neighbor_down() != 154:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_liveevent_as_neighbor_up() != 25727:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_liveevent_as_sync_finished() != 14329:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_liveevent_type() != 35533:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_namespaceid_equal() != 18805:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_namespaceid_to_string() != 63715:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_nodeaddr_derp_region() != 62080:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_nodeaddr_direct_addresses() != 20857:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_nodeaddr_equal() != 45841:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_publickey_equal() != 10645:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_publickey_fmt_short() != 33947:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_publickey_to_bytes() != 54334:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_publickey_to_string() != 48998:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_query_limit() != 6405:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_query_offset() != 5309:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_requesttoken_as_bytes() != 10828:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_requesttoken_equal() != 58929:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_socketaddr_as_ipv4() != 50860:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_socketaddr_as_ipv6() != 40970:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_socketaddr_equal() != 1891:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_socketaddr_type() != 50972:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_socketaddrv4_equal() != 51550:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_socketaddrv4_ip() != 54004:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_socketaddrv4_port() != 34504:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_socketaddrv4_to_string() != 43672:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_socketaddrv6_equal() != 37651:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_socketaddrv6_ip() != 49803:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_socketaddrv6_port() != 39562:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_socketaddrv6_to_string() != 14154:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_tag_equal() != 62383:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_tag_to_bytes() != 33917:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_tag_to_string() != 65488:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_authorid_from_string() != 14210:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_blobdownloadrequest_new() != 24971:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_docticket_from_string() != 40262:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_downloadlocation_external() != 45372:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_downloadlocation_internal() != 751:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_hash_from_bytes() != 19134:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_hash_from_cid_bytes() != 58235:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_hash_from_string() != 41770:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_hash_new() != 22809:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_ipv4addr_from_string() != 60777:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_ipv4addr_new() != 51336:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_ipv6addr_from_string() != 24533:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_ipv6addr_new() != 18364:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_irohnode_new() != 22562:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_namespaceid_from_string() != 47535:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_nodeaddr_new() != 42954:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_publickey_from_bytes() != 65104:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_publickey_from_string() != 18975:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_query_all() != 18362:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_query_author() != 6757:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_query_author_key_exact() != 21618:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_query_author_key_prefix() != 63753:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_query_key_exact() != 32100:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_query_key_prefix() != 44412:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_query_single_latest_per_key() != 42778:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_requesttoken_from_string() != 49791:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_requesttoken_generate() != 37061:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_requesttoken_new() != 37150:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_settagoption_auto() != 13040:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_settagoption_named() != 24631:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_socketaddr_from_ipv4() != 48670:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_socketaddr_from_ipv6() != 45955:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_socketaddrv4_from_string() != 16157:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_socketaddrv4_new() != 12651:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_socketaddrv6_from_string() != 22443:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_socketaddrv6_new() != 46347:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_tag_from_bytes() != 48807:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_tag_from_string() != 40751:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_wrapoption_no_wrap() != 60952:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_constructor_wrapoption_wrap() != 59295:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_addcallback_progress() != 42266:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_docexportfilecallback_progress() != 20951:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_docimportfilecallback_progress() != 18783:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_downloadcallback_progress() != 64403:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_iroh_checksum_method_subscribecallback_event() != 18725:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")

# A ctypes library to expose the extern-C FFI definitions.
# This is an implementation detail which will be called internally by the public API.

_UniffiLib = _uniffi_load_indirect()
_UniffiLib.uniffi_iroh_fn_free_addprogress.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_free_addprogress.restype = None
_UniffiLib.uniffi_iroh_fn_method_addprogress_as_abort.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_addprogress_as_abort.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_addprogress_as_all_done.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_addprogress_as_all_done.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_addprogress_as_done.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_addprogress_as_done.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_addprogress_as_found.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_addprogress_as_found.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_addprogress_as_progress.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_addprogress_as_progress.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_addprogress_type.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_addprogress_type.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_free_authorid.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_free_authorid.restype = None
_UniffiLib.uniffi_iroh_fn_constructor_authorid_from_string.argtypes = (
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_authorid_from_string.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_authorid_equal.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_authorid_equal.restype = ctypes.c_int8
_UniffiLib.uniffi_iroh_fn_method_authorid_to_string.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_authorid_to_string.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_free_blobdownloadrequest.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_free_blobdownloadrequest.restype = None
_UniffiLib.uniffi_iroh_fn_constructor_blobdownloadrequest_new.argtypes = (
    ctypes.c_void_p,
    _UniffiRustBuffer,
    ctypes.c_void_p,
    ctypes.c_void_p,
    ctypes.c_void_p,
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_blobdownloadrequest_new.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_free_directaddrinfo.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_free_directaddrinfo.restype = None
_UniffiLib.uniffi_iroh_fn_free_doc.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_free_doc.restype = None
_UniffiLib.uniffi_iroh_fn_method_doc_close.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_doc_close.restype = None
_UniffiLib.uniffi_iroh_fn_method_doc_del.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_doc_del.restype = ctypes.c_uint64
_UniffiLib.uniffi_iroh_fn_method_doc_export_file.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    _UniffiRustBuffer,
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_doc_export_file.restype = None
_UniffiLib.uniffi_iroh_fn_method_doc_get_many.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_doc_get_many.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_doc_get_one.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_doc_get_one.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_doc_id.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_doc_id.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_doc_import_file.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    _UniffiRustBuffer,
    _UniffiRustBuffer,
    ctypes.c_int8,
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_doc_import_file.restype = None
_UniffiLib.uniffi_iroh_fn_method_doc_leave.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_doc_leave.restype = None
_UniffiLib.uniffi_iroh_fn_method_doc_read_to_bytes.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_doc_read_to_bytes.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_doc_set_bytes.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    _UniffiRustBuffer,
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_doc_set_bytes.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_doc_set_hash.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    _UniffiRustBuffer,
    ctypes.c_void_p,
    ctypes.c_uint64,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_doc_set_hash.restype = None
_UniffiLib.uniffi_iroh_fn_method_doc_share.argtypes = (
    ctypes.c_void_p,
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_doc_share.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_doc_size.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_doc_size.restype = ctypes.c_uint64
_UniffiLib.uniffi_iroh_fn_method_doc_start_sync.argtypes = (
    ctypes.c_void_p,
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_doc_start_sync.restype = None
_UniffiLib.uniffi_iroh_fn_method_doc_status.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_doc_status.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_doc_subscribe.argtypes = (
    ctypes.c_void_p,
    ctypes.c_uint64,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_doc_subscribe.restype = None
_UniffiLib.uniffi_iroh_fn_free_docexportprogress.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_free_docexportprogress.restype = None
_UniffiLib.uniffi_iroh_fn_method_docexportprogress_as_abort.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_docexportprogress_as_abort.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_docexportprogress_as_found.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_docexportprogress_as_found.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_docexportprogress_as_progress.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_docexportprogress_as_progress.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_docexportprogress_type.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_docexportprogress_type.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_free_docimportprogress.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_free_docimportprogress.restype = None
_UniffiLib.uniffi_iroh_fn_method_docimportprogress_as_abort.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_docimportprogress_as_abort.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_docimportprogress_as_all_done.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_docimportprogress_as_all_done.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_docimportprogress_as_found.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_docimportprogress_as_found.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_docimportprogress_as_ingest_done.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_docimportprogress_as_ingest_done.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_docimportprogress_as_progress.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_docimportprogress_as_progress.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_docimportprogress_type.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_docimportprogress_type.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_free_docticket.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_free_docticket.restype = None
_UniffiLib.uniffi_iroh_fn_constructor_docticket_from_string.argtypes = (
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_docticket_from_string.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_docticket_equal.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_docticket_equal.restype = ctypes.c_int8
_UniffiLib.uniffi_iroh_fn_method_docticket_to_string.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_docticket_to_string.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_free_downloadlocation.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_free_downloadlocation.restype = None
_UniffiLib.uniffi_iroh_fn_constructor_downloadlocation_external.argtypes = (
    _UniffiRustBuffer,
    ctypes.c_int8,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_downloadlocation_external.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_constructor_downloadlocation_internal.argtypes = (
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_downloadlocation_internal.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_free_downloadprogress.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_free_downloadprogress.restype = None
_UniffiLib.uniffi_iroh_fn_method_downloadprogress_as_abort.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_downloadprogress_as_abort.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_downloadprogress_as_done.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_downloadprogress_as_done.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_downloadprogress_as_export.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_downloadprogress_as_export.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_downloadprogress_as_export_progress.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_downloadprogress_as_export_progress.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_downloadprogress_as_found.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_downloadprogress_as_found.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_downloadprogress_as_found_hash_seq.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_downloadprogress_as_found_hash_seq.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_downloadprogress_as_network_done.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_downloadprogress_as_network_done.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_downloadprogress_as_progress.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_downloadprogress_as_progress.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_downloadprogress_type.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_downloadprogress_type.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_free_entry.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_free_entry.restype = None
_UniffiLib.uniffi_iroh_fn_method_entry_author.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_entry_author.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_entry_content_hash.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_entry_content_hash.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_entry_content_len.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_entry_content_len.restype = ctypes.c_uint64
_UniffiLib.uniffi_iroh_fn_method_entry_key.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_entry_key.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_entry_namespace.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_entry_namespace.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_free_hash.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_free_hash.restype = None
_UniffiLib.uniffi_iroh_fn_constructor_hash_from_bytes.argtypes = (
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_hash_from_bytes.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_constructor_hash_from_cid_bytes.argtypes = (
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_hash_from_cid_bytes.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_constructor_hash_from_string.argtypes = (
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_hash_from_string.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_constructor_hash_new.argtypes = (
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_hash_new.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_hash_as_cid_bytes.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_hash_as_cid_bytes.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_hash_equal.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_hash_equal.restype = ctypes.c_int8
_UniffiLib.uniffi_iroh_fn_method_hash_to_bytes.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_hash_to_bytes.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_hash_to_hex.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_hash_to_hex.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_hash_to_string.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_hash_to_string.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_free_ipv4addr.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_free_ipv4addr.restype = None
_UniffiLib.uniffi_iroh_fn_constructor_ipv4addr_from_string.argtypes = (
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_ipv4addr_from_string.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_constructor_ipv4addr_new.argtypes = (
    ctypes.c_uint8,
    ctypes.c_uint8,
    ctypes.c_uint8,
    ctypes.c_uint8,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_ipv4addr_new.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_ipv4addr_equal.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_ipv4addr_equal.restype = ctypes.c_int8
_UniffiLib.uniffi_iroh_fn_method_ipv4addr_octets.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_ipv4addr_octets.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_ipv4addr_to_string.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_ipv4addr_to_string.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_free_ipv6addr.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_free_ipv6addr.restype = None
_UniffiLib.uniffi_iroh_fn_constructor_ipv6addr_from_string.argtypes = (
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_ipv6addr_from_string.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_constructor_ipv6addr_new.argtypes = (
    ctypes.c_uint16,
    ctypes.c_uint16,
    ctypes.c_uint16,
    ctypes.c_uint16,
    ctypes.c_uint16,
    ctypes.c_uint16,
    ctypes.c_uint16,
    ctypes.c_uint16,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_ipv6addr_new.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_ipv6addr_equal.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_ipv6addr_equal.restype = ctypes.c_int8
_UniffiLib.uniffi_iroh_fn_method_ipv6addr_segments.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_ipv6addr_segments.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_ipv6addr_to_string.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_ipv6addr_to_string.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_free_irohnode.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_free_irohnode.restype = None
_UniffiLib.uniffi_iroh_fn_constructor_irohnode_new.argtypes = (
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_irohnode_new.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_irohnode_author_create.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_irohnode_author_create.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_irohnode_author_list.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_irohnode_author_list.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_add_bytes.argtypes = (
    ctypes.c_void_p,
    _UniffiRustBuffer,
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_add_bytes.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_add_from_path.argtypes = (
    ctypes.c_void_p,
    _UniffiRustBuffer,
    ctypes.c_int8,
    ctypes.c_void_p,
    ctypes.c_void_p,
    ctypes.c_uint64,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_add_from_path.restype = None
_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_delete_blob.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_delete_blob.restype = None
_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_download.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    ctypes.c_uint64,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_download.restype = None
_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_list.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_list.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_list_collections.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_list_collections.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_list_incomplete.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_list_incomplete.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_read_to_bytes.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_read_to_bytes.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_size.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_size.restype = ctypes.c_uint64
_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_write_to_path.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_write_to_path.restype = None
_UniffiLib.uniffi_iroh_fn_method_irohnode_connection_info.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_irohnode_connection_info.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_irohnode_connections.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_irohnode_connections.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_irohnode_doc_create.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_irohnode_doc_create.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_irohnode_doc_join.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_irohnode_doc_join.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_irohnode_doc_list.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_irohnode_doc_list.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_irohnode_node_id.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_irohnode_node_id.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_irohnode_stats.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_irohnode_stats.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_free_liveevent.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_free_liveevent.restype = None
_UniffiLib.uniffi_iroh_fn_method_liveevent_as_content_ready.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_liveevent_as_content_ready.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_liveevent_as_insert_local.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_liveevent_as_insert_local.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_liveevent_as_insert_remote.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_liveevent_as_insert_remote.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_liveevent_as_neighbor_down.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_liveevent_as_neighbor_down.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_liveevent_as_neighbor_up.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_liveevent_as_neighbor_up.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_liveevent_as_sync_finished.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_liveevent_as_sync_finished.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_liveevent_type.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_liveevent_type.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_free_namespaceid.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_free_namespaceid.restype = None
_UniffiLib.uniffi_iroh_fn_constructor_namespaceid_from_string.argtypes = (
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_namespaceid_from_string.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_namespaceid_equal.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_namespaceid_equal.restype = ctypes.c_int8
_UniffiLib.uniffi_iroh_fn_method_namespaceid_to_string.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_namespaceid_to_string.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_free_nodeaddr.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_free_nodeaddr.restype = None
_UniffiLib.uniffi_iroh_fn_constructor_nodeaddr_new.argtypes = (
    ctypes.c_void_p,
    _UniffiRustBuffer,
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_nodeaddr_new.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_nodeaddr_derp_region.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_nodeaddr_derp_region.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_nodeaddr_direct_addresses.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_nodeaddr_direct_addresses.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_nodeaddr_equal.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_nodeaddr_equal.restype = ctypes.c_int8
_UniffiLib.uniffi_iroh_fn_free_publickey.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_free_publickey.restype = None
_UniffiLib.uniffi_iroh_fn_constructor_publickey_from_bytes.argtypes = (
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_publickey_from_bytes.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_constructor_publickey_from_string.argtypes = (
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_publickey_from_string.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_publickey_equal.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_publickey_equal.restype = ctypes.c_int8
_UniffiLib.uniffi_iroh_fn_method_publickey_fmt_short.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_publickey_fmt_short.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_publickey_to_bytes.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_publickey_to_bytes.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_publickey_to_string.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_publickey_to_string.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_free_query.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_free_query.restype = None
_UniffiLib.uniffi_iroh_fn_constructor_query_all.argtypes = (
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_query_all.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_constructor_query_author.argtypes = (
    ctypes.c_void_p,
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_query_author.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_constructor_query_author_key_exact.argtypes = (
    ctypes.c_void_p,
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_query_author_key_exact.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_constructor_query_author_key_prefix.argtypes = (
    ctypes.c_void_p,
    _UniffiRustBuffer,
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_query_author_key_prefix.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_constructor_query_key_exact.argtypes = (
    _UniffiRustBuffer,
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_query_key_exact.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_constructor_query_key_prefix.argtypes = (
    _UniffiRustBuffer,
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_query_key_prefix.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_constructor_query_single_latest_per_key.argtypes = (
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_query_single_latest_per_key.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_query_limit.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_query_limit.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_query_offset.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_query_offset.restype = ctypes.c_uint64
_UniffiLib.uniffi_iroh_fn_free_requesttoken.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_free_requesttoken.restype = None
_UniffiLib.uniffi_iroh_fn_constructor_requesttoken_from_string.argtypes = (
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_requesttoken_from_string.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_constructor_requesttoken_generate.argtypes = (
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_requesttoken_generate.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_constructor_requesttoken_new.argtypes = (
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_requesttoken_new.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_requesttoken_as_bytes.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_requesttoken_as_bytes.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_requesttoken_equal.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_requesttoken_equal.restype = ctypes.c_int8
_UniffiLib.uniffi_iroh_fn_free_settagoption.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_free_settagoption.restype = None
_UniffiLib.uniffi_iroh_fn_constructor_settagoption_auto.argtypes = (
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_settagoption_auto.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_constructor_settagoption_named.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_settagoption_named.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_free_socketaddr.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_free_socketaddr.restype = None
_UniffiLib.uniffi_iroh_fn_constructor_socketaddr_from_ipv4.argtypes = (
    ctypes.c_void_p,
    ctypes.c_uint16,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_socketaddr_from_ipv4.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_constructor_socketaddr_from_ipv6.argtypes = (
    ctypes.c_void_p,
    ctypes.c_uint16,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_socketaddr_from_ipv6.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_socketaddr_as_ipv4.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_socketaddr_as_ipv4.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_socketaddr_as_ipv6.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_socketaddr_as_ipv6.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_socketaddr_equal.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_socketaddr_equal.restype = ctypes.c_int8
_UniffiLib.uniffi_iroh_fn_method_socketaddr_type.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_socketaddr_type.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_free_socketaddrv4.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_free_socketaddrv4.restype = None
_UniffiLib.uniffi_iroh_fn_constructor_socketaddrv4_from_string.argtypes = (
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_socketaddrv4_from_string.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_constructor_socketaddrv4_new.argtypes = (
    ctypes.c_void_p,
    ctypes.c_uint16,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_socketaddrv4_new.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_socketaddrv4_equal.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_socketaddrv4_equal.restype = ctypes.c_int8
_UniffiLib.uniffi_iroh_fn_method_socketaddrv4_ip.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_socketaddrv4_ip.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_socketaddrv4_port.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_socketaddrv4_port.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_fn_method_socketaddrv4_to_string.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_socketaddrv4_to_string.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_free_socketaddrv6.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_free_socketaddrv6.restype = None
_UniffiLib.uniffi_iroh_fn_constructor_socketaddrv6_from_string.argtypes = (
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_socketaddrv6_from_string.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_constructor_socketaddrv6_new.argtypes = (
    ctypes.c_void_p,
    ctypes.c_uint16,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_socketaddrv6_new.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_socketaddrv6_equal.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_socketaddrv6_equal.restype = ctypes.c_int8
_UniffiLib.uniffi_iroh_fn_method_socketaddrv6_ip.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_socketaddrv6_ip.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_socketaddrv6_port.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_socketaddrv6_port.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_fn_method_socketaddrv6_to_string.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_socketaddrv6_to_string.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_free_tag.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_free_tag.restype = None
_UniffiLib.uniffi_iroh_fn_constructor_tag_from_bytes.argtypes = (
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_tag_from_bytes.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_constructor_tag_from_string.argtypes = (
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_tag_from_string.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_method_tag_equal.argtypes = (
    ctypes.c_void_p,
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_tag_equal.restype = ctypes.c_int8
_UniffiLib.uniffi_iroh_fn_method_tag_to_bytes.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_tag_to_bytes.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_method_tag_to_string.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_method_tag_to_string.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_free_wrapoption.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_free_wrapoption.restype = None
_UniffiLib.uniffi_iroh_fn_constructor_wrapoption_no_wrap.argtypes = (
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_wrapoption_no_wrap.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_constructor_wrapoption_wrap.argtypes = (
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_constructor_wrapoption_wrap.restype = ctypes.c_void_p
_UniffiLib.uniffi_iroh_fn_init_callback_addcallback.argtypes = (
    _UNIFFI_FOREIGN_CALLBACK_T,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_init_callback_addcallback.restype = None
_UniffiLib.uniffi_iroh_fn_init_callback_docexportfilecallback.argtypes = (
    _UNIFFI_FOREIGN_CALLBACK_T,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_init_callback_docexportfilecallback.restype = None
_UniffiLib.uniffi_iroh_fn_init_callback_docimportfilecallback.argtypes = (
    _UNIFFI_FOREIGN_CALLBACK_T,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_init_callback_docimportfilecallback.restype = None
_UniffiLib.uniffi_iroh_fn_init_callback_downloadcallback.argtypes = (
    _UNIFFI_FOREIGN_CALLBACK_T,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_init_callback_downloadcallback.restype = None
_UniffiLib.uniffi_iroh_fn_init_callback_subscribecallback.argtypes = (
    _UNIFFI_FOREIGN_CALLBACK_T,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_init_callback_subscribecallback.restype = None
_UniffiLib.uniffi_iroh_fn_func_key_to_path.argtypes = (
    _UniffiRustBuffer,
    _UniffiRustBuffer,
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_func_key_to_path.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_func_path_to_key.argtypes = (
    _UniffiRustBuffer,
    _UniffiRustBuffer,
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_func_path_to_key.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_fn_func_set_log_level.argtypes = (
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_func_set_log_level.restype = None
_UniffiLib.uniffi_iroh_fn_func_start_metrics_collection.argtypes = (
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_iroh_fn_func_start_metrics_collection.restype = None
_UniffiLib.ffi_iroh_rustbuffer_alloc.argtypes = (
    ctypes.c_int32,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_iroh_rustbuffer_alloc.restype = _UniffiRustBuffer
_UniffiLib.ffi_iroh_rustbuffer_from_bytes.argtypes = (
    _UniffiForeignBytes,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_iroh_rustbuffer_from_bytes.restype = _UniffiRustBuffer
_UniffiLib.ffi_iroh_rustbuffer_free.argtypes = (
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_iroh_rustbuffer_free.restype = None
_UniffiLib.ffi_iroh_rustbuffer_reserve.argtypes = (
    _UniffiRustBuffer,
    ctypes.c_int32,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_iroh_rustbuffer_reserve.restype = _UniffiRustBuffer
_UniffiLib.uniffi_iroh_checksum_func_key_to_path.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_func_key_to_path.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_func_path_to_key.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_func_path_to_key.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_func_set_log_level.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_func_set_log_level.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_func_start_metrics_collection.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_func_start_metrics_collection.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_addprogress_as_abort.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_addprogress_as_abort.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_addprogress_as_all_done.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_addprogress_as_all_done.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_addprogress_as_done.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_addprogress_as_done.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_addprogress_as_found.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_addprogress_as_found.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_addprogress_as_progress.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_addprogress_as_progress.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_addprogress_type.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_addprogress_type.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_authorid_equal.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_authorid_equal.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_authorid_to_string.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_authorid_to_string.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_doc_close.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_doc_close.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_doc_del.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_doc_del.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_doc_export_file.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_doc_export_file.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_doc_get_many.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_doc_get_many.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_doc_get_one.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_doc_get_one.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_doc_id.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_doc_id.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_doc_import_file.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_doc_import_file.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_doc_leave.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_doc_leave.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_doc_read_to_bytes.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_doc_read_to_bytes.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_doc_set_bytes.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_doc_set_bytes.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_doc_set_hash.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_doc_set_hash.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_doc_share.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_doc_share.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_doc_size.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_doc_size.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_doc_start_sync.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_doc_start_sync.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_doc_status.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_doc_status.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_doc_subscribe.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_doc_subscribe.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_docexportprogress_as_abort.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_docexportprogress_as_abort.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_docexportprogress_as_found.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_docexportprogress_as_found.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_docexportprogress_as_progress.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_docexportprogress_as_progress.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_docexportprogress_type.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_docexportprogress_type.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_docimportprogress_as_abort.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_docimportprogress_as_abort.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_docimportprogress_as_all_done.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_docimportprogress_as_all_done.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_docimportprogress_as_found.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_docimportprogress_as_found.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_docimportprogress_as_ingest_done.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_docimportprogress_as_ingest_done.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_docimportprogress_as_progress.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_docimportprogress_as_progress.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_docimportprogress_type.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_docimportprogress_type.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_docticket_equal.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_docticket_equal.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_docticket_to_string.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_docticket_to_string.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_downloadprogress_as_abort.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_downloadprogress_as_abort.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_downloadprogress_as_done.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_downloadprogress_as_done.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_downloadprogress_as_export.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_downloadprogress_as_export.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_downloadprogress_as_export_progress.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_downloadprogress_as_export_progress.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_downloadprogress_as_found.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_downloadprogress_as_found.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_downloadprogress_as_found_hash_seq.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_downloadprogress_as_found_hash_seq.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_downloadprogress_as_network_done.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_downloadprogress_as_network_done.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_downloadprogress_as_progress.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_downloadprogress_as_progress.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_downloadprogress_type.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_downloadprogress_type.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_entry_author.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_entry_author.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_entry_content_hash.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_entry_content_hash.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_entry_content_len.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_entry_content_len.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_entry_key.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_entry_key.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_entry_namespace.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_entry_namespace.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_hash_as_cid_bytes.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_hash_as_cid_bytes.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_hash_equal.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_hash_equal.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_hash_to_bytes.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_hash_to_bytes.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_hash_to_hex.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_hash_to_hex.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_hash_to_string.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_hash_to_string.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_ipv4addr_equal.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_ipv4addr_equal.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_ipv4addr_octets.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_ipv4addr_octets.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_ipv4addr_to_string.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_ipv4addr_to_string.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_ipv6addr_equal.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_ipv6addr_equal.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_ipv6addr_segments.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_ipv6addr_segments.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_ipv6addr_to_string.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_ipv6addr_to_string.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_irohnode_author_create.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_irohnode_author_create.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_irohnode_author_list.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_irohnode_author_list.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_irohnode_blobs_add_bytes.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_irohnode_blobs_add_bytes.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_irohnode_blobs_add_from_path.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_irohnode_blobs_add_from_path.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_irohnode_blobs_delete_blob.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_irohnode_blobs_delete_blob.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_irohnode_blobs_download.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_irohnode_blobs_download.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_irohnode_blobs_list.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_irohnode_blobs_list.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_irohnode_blobs_list_collections.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_irohnode_blobs_list_collections.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_irohnode_blobs_list_incomplete.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_irohnode_blobs_list_incomplete.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_irohnode_blobs_read_to_bytes.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_irohnode_blobs_read_to_bytes.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_irohnode_blobs_size.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_irohnode_blobs_size.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_irohnode_blobs_write_to_path.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_irohnode_blobs_write_to_path.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_irohnode_connection_info.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_irohnode_connection_info.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_irohnode_connections.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_irohnode_connections.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_irohnode_doc_create.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_irohnode_doc_create.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_irohnode_doc_join.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_irohnode_doc_join.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_irohnode_doc_list.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_irohnode_doc_list.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_irohnode_node_id.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_irohnode_node_id.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_irohnode_stats.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_irohnode_stats.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_liveevent_as_content_ready.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_liveevent_as_content_ready.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_liveevent_as_insert_local.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_liveevent_as_insert_local.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_liveevent_as_insert_remote.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_liveevent_as_insert_remote.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_liveevent_as_neighbor_down.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_liveevent_as_neighbor_down.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_liveevent_as_neighbor_up.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_liveevent_as_neighbor_up.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_liveevent_as_sync_finished.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_liveevent_as_sync_finished.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_liveevent_type.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_liveevent_type.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_namespaceid_equal.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_namespaceid_equal.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_namespaceid_to_string.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_namespaceid_to_string.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_nodeaddr_derp_region.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_nodeaddr_derp_region.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_nodeaddr_direct_addresses.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_nodeaddr_direct_addresses.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_nodeaddr_equal.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_nodeaddr_equal.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_publickey_equal.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_publickey_equal.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_publickey_fmt_short.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_publickey_fmt_short.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_publickey_to_bytes.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_publickey_to_bytes.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_publickey_to_string.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_publickey_to_string.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_query_limit.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_query_limit.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_query_offset.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_query_offset.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_requesttoken_as_bytes.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_requesttoken_as_bytes.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_requesttoken_equal.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_requesttoken_equal.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_socketaddr_as_ipv4.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_socketaddr_as_ipv4.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_socketaddr_as_ipv6.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_socketaddr_as_ipv6.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_socketaddr_equal.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_socketaddr_equal.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_socketaddr_type.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_socketaddr_type.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_socketaddrv4_equal.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_socketaddrv4_equal.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_socketaddrv4_ip.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_socketaddrv4_ip.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_socketaddrv4_port.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_socketaddrv4_port.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_socketaddrv4_to_string.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_socketaddrv4_to_string.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_socketaddrv6_equal.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_socketaddrv6_equal.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_socketaddrv6_ip.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_socketaddrv6_ip.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_socketaddrv6_port.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_socketaddrv6_port.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_socketaddrv6_to_string.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_socketaddrv6_to_string.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_tag_equal.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_tag_equal.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_tag_to_bytes.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_tag_to_bytes.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_tag_to_string.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_tag_to_string.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_authorid_from_string.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_authorid_from_string.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_blobdownloadrequest_new.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_blobdownloadrequest_new.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_docticket_from_string.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_docticket_from_string.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_downloadlocation_external.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_downloadlocation_external.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_downloadlocation_internal.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_downloadlocation_internal.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_hash_from_bytes.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_hash_from_bytes.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_hash_from_cid_bytes.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_hash_from_cid_bytes.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_hash_from_string.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_hash_from_string.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_hash_new.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_hash_new.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_ipv4addr_from_string.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_ipv4addr_from_string.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_ipv4addr_new.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_ipv4addr_new.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_ipv6addr_from_string.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_ipv6addr_from_string.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_ipv6addr_new.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_ipv6addr_new.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_irohnode_new.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_irohnode_new.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_namespaceid_from_string.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_namespaceid_from_string.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_nodeaddr_new.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_nodeaddr_new.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_publickey_from_bytes.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_publickey_from_bytes.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_publickey_from_string.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_publickey_from_string.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_query_all.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_query_all.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_query_author.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_query_author.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_query_author_key_exact.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_query_author_key_exact.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_query_author_key_prefix.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_query_author_key_prefix.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_query_key_exact.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_query_key_exact.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_query_key_prefix.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_query_key_prefix.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_query_single_latest_per_key.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_query_single_latest_per_key.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_requesttoken_from_string.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_requesttoken_from_string.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_requesttoken_generate.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_requesttoken_generate.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_requesttoken_new.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_requesttoken_new.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_settagoption_auto.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_settagoption_auto.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_settagoption_named.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_settagoption_named.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_socketaddr_from_ipv4.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_socketaddr_from_ipv4.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_socketaddr_from_ipv6.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_socketaddr_from_ipv6.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_socketaddrv4_from_string.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_socketaddrv4_from_string.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_socketaddrv4_new.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_socketaddrv4_new.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_socketaddrv6_from_string.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_socketaddrv6_from_string.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_socketaddrv6_new.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_socketaddrv6_new.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_tag_from_bytes.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_tag_from_bytes.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_tag_from_string.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_tag_from_string.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_wrapoption_no_wrap.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_wrapoption_no_wrap.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_constructor_wrapoption_wrap.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_constructor_wrapoption_wrap.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_addcallback_progress.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_addcallback_progress.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_docexportfilecallback_progress.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_docexportfilecallback_progress.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_docimportfilecallback_progress.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_docimportfilecallback_progress.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_downloadcallback_progress.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_downloadcallback_progress.restype = ctypes.c_uint16
_UniffiLib.uniffi_iroh_checksum_method_subscribecallback_event.argtypes = (
)
_UniffiLib.uniffi_iroh_checksum_method_subscribecallback_event.restype = ctypes.c_uint16
_UniffiLib.ffi_iroh_uniffi_contract_version.argtypes = (
)
_UniffiLib.ffi_iroh_uniffi_contract_version.restype = ctypes.c_uint32
_uniffi_check_contract_api_version(_UniffiLib)
_uniffi_check_api_checksums(_UniffiLib)

# Public interface members begin here.


class _UniffiConverterUInt8(_UniffiConverterPrimitiveInt):
    CLASS_NAME = "u8"
    VALUE_MIN = 0
    VALUE_MAX = 2**8

    @staticmethod
    def read(buf):
        return buf.read_u8()

    @staticmethod
    def write_unchecked(value, buf):
        buf.write_u8(value)

class _UniffiConverterUInt16(_UniffiConverterPrimitiveInt):
    CLASS_NAME = "u16"
    VALUE_MIN = 0
    VALUE_MAX = 2**16

    @staticmethod
    def read(buf):
        return buf.read_u16()

    @staticmethod
    def write_unchecked(value, buf):
        buf.write_u16(value)

class _UniffiConverterUInt64(_UniffiConverterPrimitiveInt):
    CLASS_NAME = "u64"
    VALUE_MIN = 0
    VALUE_MAX = 2**64

    @staticmethod
    def read(buf):
        return buf.read_u64()

    @staticmethod
    def write_unchecked(value, buf):
        buf.write_u64(value)

class _UniffiConverterBool(_UniffiConverterPrimitive):
    @classmethod
    def check(cls, value):
        return not not value

    @classmethod
    def read(cls, buf):
        return cls.lift(buf.read_u8())

    @classmethod
    def write_unchecked(cls, value, buf):
        buf.write_u8(value)

    @staticmethod
    def lift(value):
        return value != 0

class _UniffiConverterString:
    @staticmethod
    def check(value):
        if not isinstance(value, str):
            raise TypeError("argument must be str, not {}".format(type(value).__name__))
        return value

    @staticmethod
    def read(buf):
        size = buf.read_i32()
        if size < 0:
            raise InternalError("Unexpected negative string length")
        utf8_bytes = buf.read(size)
        return utf8_bytes.decode("utf-8")

    @staticmethod
    def write(value, buf):
        value = _UniffiConverterString.check(value)
        utf8_bytes = value.encode("utf-8")
        buf.write_i32(len(utf8_bytes))
        buf.write(utf8_bytes)

    @staticmethod
    def lift(buf):
        with buf.consume_with_stream() as stream:
            return stream.read(stream.remaining()).decode("utf-8")

    @staticmethod
    def lower(value):
        value = _UniffiConverterString.check(value)
        with _UniffiRustBuffer.alloc_with_builder() as builder:
            builder.write(value.encode("utf-8"))
            return builder.finalize()

class _UniffiConverterBytes(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        size = buf.read_i32()
        if size < 0:
            raise InternalError("Unexpected negative byte string length")
        return buf.read(size)

    @staticmethod
    def write(value, buf):
        try:
            memoryview(value)
        except TypeError:
            raise TypeError("a bytes-like object is required, not {!r}".format(type(value).__name__))
        buf.write_i32(len(value))
        buf.write(value)

# The Timestamp type.
Timestamp = datetime.datetime

# There is a loss of precision when converting from Rust timestamps,
# which are accurate to the nanosecond,
# to Python datetimes, which have a variable precision due to the use of float as representation.
class _UniffiConverterTimestamp(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        seconds = buf.read_i64()
        microseconds = buf.read_u32() / 1000
        # Use fromtimestamp(0) then add the seconds using a timedelta.  This
        # ensures that we get OverflowError rather than ValueError when
        # seconds is too large.
        if seconds >= 0:
            return datetime.datetime.fromtimestamp(0, tz=datetime.timezone.utc) + datetime.timedelta(seconds=seconds, microseconds=microseconds)
        else:
            return datetime.datetime.fromtimestamp(0, tz=datetime.timezone.utc) - datetime.timedelta(seconds=-seconds, microseconds=microseconds)

    @staticmethod
    def write(value, buf):
        if value >= datetime.datetime.fromtimestamp(0, datetime.timezone.utc):
            sign = 1
            delta = value - datetime.datetime.fromtimestamp(0, datetime.timezone.utc)
        else:
            sign = -1
            delta = datetime.datetime.fromtimestamp(0, datetime.timezone.utc) - value

        seconds = delta.seconds + delta.days * 24 * 3600
        nanoseconds = delta.microseconds * 1000
        buf.write_i64(sign * seconds)
        buf.write_u32(nanoseconds)

# The Duration type.
Duration = datetime.timedelta

# There is a loss of precision when converting from Rust durations,
# which are accurate to the nanosecond,
# to Python durations, which are only accurate to the microsecond.
class _UniffiConverterDuration(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        seconds = buf.read_u64()
        microseconds = buf.read_u32() / 1.0e3
        return datetime.timedelta(seconds=seconds, microseconds=microseconds)

    @staticmethod
    def write(value, buf):
        seconds = value.seconds + value.days * 24 * 3600
        nanoseconds = value.microseconds * 1000
        if seconds < 0:
            raise ValueError("Invalid duration, must be non-negative")
        buf.write_i64(seconds)
        buf.write_u32(nanoseconds)



class AddProgress:
    _pointer: ctypes.c_void_p

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_iroh_fn_free_addprogress, pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst


    def as_abort(self, ) -> "AddProgressAbort":
        return _UniffiConverterTypeAddProgressAbort.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_addprogress_as_abort,self._pointer,)
        )






    def as_all_done(self, ) -> "AddProgressAllDone":
        return _UniffiConverterTypeAddProgressAllDone.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_addprogress_as_all_done,self._pointer,)
        )






    def as_done(self, ) -> "AddProgressDone":
        return _UniffiConverterTypeAddProgressDone.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_addprogress_as_done,self._pointer,)
        )






    def as_found(self, ) -> "AddProgressFound":
        return _UniffiConverterTypeAddProgressFound.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_addprogress_as_found,self._pointer,)
        )






    def as_progress(self, ) -> "AddProgressProgress":
        return _UniffiConverterTypeAddProgressProgress.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_addprogress_as_progress,self._pointer,)
        )






    def type(self, ) -> "AddProgressType":
        return _UniffiConverterTypeAddProgressType.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_addprogress_type,self._pointer,)
        )






class _UniffiConverterTypeAddProgress:
    @classmethod
    def read(cls, buf):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value, buf):
        if not isinstance(value, AddProgress):
            raise TypeError("Expected AddProgress instance, {} found".format(type(value).__name__))
        buf.write_u64(cls.lower(value))

    @staticmethod
    def lift(value):
        return AddProgress._make_instance_(value)

    @staticmethod
    def lower(value):
        return value._pointer



class AuthorId:
    _pointer: ctypes.c_void_p

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_iroh_fn_free_authorid, pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst

    @classmethod
    def from_string(cls, str: "str"):
        
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call_with_error(_UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_constructor_authorid_from_string,
        _UniffiConverterString.lower(str))
        return cls._make_instance_(pointer)



    def equal(self, other: "AuthorId") -> "bool":
        
        return _UniffiConverterBool.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_authorid_equal,self._pointer,
        _UniffiConverterTypeAuthorId.lower(other))
        )






    def to_string(self, ) -> "str":
        return _UniffiConverterString.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_authorid_to_string,self._pointer,)
        )






class _UniffiConverterTypeAuthorId:
    @classmethod
    def read(cls, buf):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value, buf):
        if not isinstance(value, AuthorId):
            raise TypeError("Expected AuthorId instance, {} found".format(type(value).__name__))
        buf.write_u64(cls.lower(value))

    @staticmethod
    def lift(value):
        return AuthorId._make_instance_(value)

    @staticmethod
    def lower(value):
        return value._pointer



class BlobDownloadRequest:
    _pointer: ctypes.c_void_p
    def __init__(self, hash: "Hash",format: "BlobFormat",node: "NodeAddr",tag: "SetTagOption",out: "DownloadLocation",token: "typing.Optional[RequestToken]"):
        
        
        
        
        
        
        self._pointer = _rust_call(_UniffiLib.uniffi_iroh_fn_constructor_blobdownloadrequest_new,
        _UniffiConverterTypeHash.lower(hash),
        _UniffiConverterTypeBlobFormat.lower(format),
        _UniffiConverterTypeNodeAddr.lower(node),
        _UniffiConverterTypeSetTagOption.lower(tag),
        _UniffiConverterTypeDownloadLocation.lower(out),
        _UniffiConverterOptionalTypeRequestToken.lower(token))

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_iroh_fn_free_blobdownloadrequest, pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst


class _UniffiConverterTypeBlobDownloadRequest:
    @classmethod
    def read(cls, buf):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value, buf):
        if not isinstance(value, BlobDownloadRequest):
            raise TypeError("Expected BlobDownloadRequest instance, {} found".format(type(value).__name__))
        buf.write_u64(cls.lower(value))

    @staticmethod
    def lift(value):
        return BlobDownloadRequest._make_instance_(value)

    @staticmethod
    def lower(value):
        return value._pointer



class DirectAddrInfo:
    _pointer: ctypes.c_void_p

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_iroh_fn_free_directaddrinfo, pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst


class _UniffiConverterTypeDirectAddrInfo:
    @classmethod
    def read(cls, buf):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value, buf):
        if not isinstance(value, DirectAddrInfo):
            raise TypeError("Expected DirectAddrInfo instance, {} found".format(type(value).__name__))
        buf.write_u64(cls.lower(value))

    @staticmethod
    def lift(value):
        return DirectAddrInfo._make_instance_(value)

    @staticmethod
    def lower(value):
        return value._pointer



class Doc:
    _pointer: ctypes.c_void_p

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_iroh_fn_free_doc, pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst


    def close(self, ):
        _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_doc_close,self._pointer,)







    def _del(self, author_id: "AuthorId",prefix: "bytes") -> "int":
        
        
        return _UniffiConverterUInt64.lift(
            _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_doc_del,self._pointer,
        _UniffiConverterTypeAuthorId.lower(author_id),
        _UniffiConverterBytes.lower(prefix))
        )






    def export_file(self, entry: "Entry",path: "str",cb: "typing.Optional[DocExportFileCallback]"):
        
        
        
        _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_doc_export_file,self._pointer,
        _UniffiConverterTypeEntry.lower(entry),
        _UniffiConverterString.lower(path),
        _UniffiConverterOptionalCallbackInterfaceDocExportFileCallback.lower(cb))







    def get_many(self, query: "Query") -> "typing.List[Entry]":
        
        return _UniffiConverterSequenceTypeEntry.lift(
            _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_doc_get_many,self._pointer,
        _UniffiConverterTypeQuery.lower(query))
        )






    def get_one(self, query: "Query") -> "typing.Optional[Entry]":
        
        return _UniffiConverterOptionalTypeEntry.lift(
            _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_doc_get_one,self._pointer,
        _UniffiConverterTypeQuery.lower(query))
        )






    def id(self, ) -> "NamespaceId":
        return _UniffiConverterTypeNamespaceId.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_doc_id,self._pointer,)
        )






    def import_file(self, author: "AuthorId",key: "bytes",path: "str",in_place: "bool",cb: "typing.Optional[DocImportFileCallback]"):
        
        
        
        
        
        _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_doc_import_file,self._pointer,
        _UniffiConverterTypeAuthorId.lower(author),
        _UniffiConverterBytes.lower(key),
        _UniffiConverterString.lower(path),
        _UniffiConverterBool.lower(in_place),
        _UniffiConverterOptionalCallbackInterfaceDocImportFileCallback.lower(cb))







    def leave(self, ):
        _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_doc_leave,self._pointer,)







    def read_to_bytes(self, entry: "Entry") -> "bytes":
        
        return _UniffiConverterBytes.lift(
            _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_doc_read_to_bytes,self._pointer,
        _UniffiConverterTypeEntry.lower(entry))
        )






    def set_bytes(self, author: "AuthorId",key: "bytes",value: "bytes") -> "Hash":
        
        
        
        return _UniffiConverterTypeHash.lift(
            _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_doc_set_bytes,self._pointer,
        _UniffiConverterTypeAuthorId.lower(author),
        _UniffiConverterBytes.lower(key),
        _UniffiConverterBytes.lower(value))
        )






    def set_hash(self, author: "AuthorId",key: "bytes",hash: "Hash",size: "int"):
        
        
        
        
        _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_doc_set_hash,self._pointer,
        _UniffiConverterTypeAuthorId.lower(author),
        _UniffiConverterBytes.lower(key),
        _UniffiConverterTypeHash.lower(hash),
        _UniffiConverterUInt64.lower(size))







    def share(self, mode: "ShareMode") -> "DocTicket":
        
        return _UniffiConverterTypeDocTicket.lift(
            _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_doc_share,self._pointer,
        _UniffiConverterTypeShareMode.lower(mode))
        )






    def size(self, entry: "Entry") -> "int":
        
        return _UniffiConverterUInt64.lift(
            _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_doc_size,self._pointer,
        _UniffiConverterTypeEntry.lower(entry))
        )






    def start_sync(self, peers: "typing.List[NodeAddr]"):
        
        _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_doc_start_sync,self._pointer,
        _UniffiConverterSequenceTypeNodeAddr.lower(peers))







    def status(self, ) -> "OpenState":
        return _UniffiConverterTypeOpenState.lift(
            _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_doc_status,self._pointer,)
        )






    def subscribe(self, cb: "SubscribeCallback"):
        
        _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_doc_subscribe,self._pointer,
        _UniffiConverterCallbackInterfaceSubscribeCallback.lower(cb))







class _UniffiConverterTypeDoc:
    @classmethod
    def read(cls, buf):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value, buf):
        if not isinstance(value, Doc):
            raise TypeError("Expected Doc instance, {} found".format(type(value).__name__))
        buf.write_u64(cls.lower(value))

    @staticmethod
    def lift(value):
        return Doc._make_instance_(value)

    @staticmethod
    def lower(value):
        return value._pointer



class DocExportProgress:
    _pointer: ctypes.c_void_p

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_iroh_fn_free_docexportprogress, pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst


    def as_abort(self, ) -> "DocExportProgressAbort":
        return _UniffiConverterTypeDocExportProgressAbort.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_docexportprogress_as_abort,self._pointer,)
        )






    def as_found(self, ) -> "DocExportProgressFound":
        return _UniffiConverterTypeDocExportProgressFound.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_docexportprogress_as_found,self._pointer,)
        )






    def as_progress(self, ) -> "DocExportProgressProgress":
        return _UniffiConverterTypeDocExportProgressProgress.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_docexportprogress_as_progress,self._pointer,)
        )






    def type(self, ) -> "DocExportProgressType":
        return _UniffiConverterTypeDocExportProgressType.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_docexportprogress_type,self._pointer,)
        )






class _UniffiConverterTypeDocExportProgress:
    @classmethod
    def read(cls, buf):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value, buf):
        if not isinstance(value, DocExportProgress):
            raise TypeError("Expected DocExportProgress instance, {} found".format(type(value).__name__))
        buf.write_u64(cls.lower(value))

    @staticmethod
    def lift(value):
        return DocExportProgress._make_instance_(value)

    @staticmethod
    def lower(value):
        return value._pointer



class DocImportProgress:
    _pointer: ctypes.c_void_p

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_iroh_fn_free_docimportprogress, pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst


    def as_abort(self, ) -> "DocImportProgressAbort":
        return _UniffiConverterTypeDocImportProgressAbort.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_docimportprogress_as_abort,self._pointer,)
        )






    def as_all_done(self, ) -> "DocImportProgressAllDone":
        return _UniffiConverterTypeDocImportProgressAllDone.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_docimportprogress_as_all_done,self._pointer,)
        )






    def as_found(self, ) -> "DocImportProgressFound":
        return _UniffiConverterTypeDocImportProgressFound.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_docimportprogress_as_found,self._pointer,)
        )






    def as_ingest_done(self, ) -> "DocImportProgressIngestDone":
        return _UniffiConverterTypeDocImportProgressIngestDone.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_docimportprogress_as_ingest_done,self._pointer,)
        )






    def as_progress(self, ) -> "DocImportProgressProgress":
        return _UniffiConverterTypeDocImportProgressProgress.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_docimportprogress_as_progress,self._pointer,)
        )






    def type(self, ) -> "DocImportProgressType":
        return _UniffiConverterTypeDocImportProgressType.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_docimportprogress_type,self._pointer,)
        )






class _UniffiConverterTypeDocImportProgress:
    @classmethod
    def read(cls, buf):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value, buf):
        if not isinstance(value, DocImportProgress):
            raise TypeError("Expected DocImportProgress instance, {} found".format(type(value).__name__))
        buf.write_u64(cls.lower(value))

    @staticmethod
    def lift(value):
        return DocImportProgress._make_instance_(value)

    @staticmethod
    def lower(value):
        return value._pointer



class DocTicket:
    _pointer: ctypes.c_void_p

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_iroh_fn_free_docticket, pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst

    @classmethod
    def from_string(cls, content: "str"):
        
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call_with_error(_UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_constructor_docticket_from_string,
        _UniffiConverterString.lower(content))
        return cls._make_instance_(pointer)



    def equal(self, other: "DocTicket") -> "bool":
        
        return _UniffiConverterBool.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_docticket_equal,self._pointer,
        _UniffiConverterTypeDocTicket.lower(other))
        )






    def to_string(self, ) -> "str":
        return _UniffiConverterString.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_docticket_to_string,self._pointer,)
        )






class _UniffiConverterTypeDocTicket:
    @classmethod
    def read(cls, buf):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value, buf):
        if not isinstance(value, DocTicket):
            raise TypeError("Expected DocTicket instance, {} found".format(type(value).__name__))
        buf.write_u64(cls.lower(value))

    @staticmethod
    def lift(value):
        return DocTicket._make_instance_(value)

    @staticmethod
    def lower(value):
        return value._pointer



class DownloadLocation:
    _pointer: ctypes.c_void_p

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_iroh_fn_free_downloadlocation, pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst

    @classmethod
    def external(cls, path: "str",in_place: "bool"):
        
        
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call(_UniffiLib.uniffi_iroh_fn_constructor_downloadlocation_external,
        _UniffiConverterString.lower(path),
        _UniffiConverterBool.lower(in_place))
        return cls._make_instance_(pointer)


    @classmethod
    def internal(cls, ):
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call(_UniffiLib.uniffi_iroh_fn_constructor_downloadlocation_internal,)
        return cls._make_instance_(pointer)



class _UniffiConverterTypeDownloadLocation:
    @classmethod
    def read(cls, buf):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value, buf):
        if not isinstance(value, DownloadLocation):
            raise TypeError("Expected DownloadLocation instance, {} found".format(type(value).__name__))
        buf.write_u64(cls.lower(value))

    @staticmethod
    def lift(value):
        return DownloadLocation._make_instance_(value)

    @staticmethod
    def lower(value):
        return value._pointer



class DownloadProgress:
    _pointer: ctypes.c_void_p

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_iroh_fn_free_downloadprogress, pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst


    def as_abort(self, ) -> "DownloadProgressAbort":
        return _UniffiConverterTypeDownloadProgressAbort.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_downloadprogress_as_abort,self._pointer,)
        )






    def as_done(self, ) -> "DownloadProgressDone":
        return _UniffiConverterTypeDownloadProgressDone.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_downloadprogress_as_done,self._pointer,)
        )






    def as_export(self, ) -> "DownloadProgressExport":
        return _UniffiConverterTypeDownloadProgressExport.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_downloadprogress_as_export,self._pointer,)
        )






    def as_export_progress(self, ) -> "DownloadProgressExportProgress":
        return _UniffiConverterTypeDownloadProgressExportProgress.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_downloadprogress_as_export_progress,self._pointer,)
        )






    def as_found(self, ) -> "DownloadProgressFound":
        return _UniffiConverterTypeDownloadProgressFound.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_downloadprogress_as_found,self._pointer,)
        )






    def as_found_hash_seq(self, ) -> "DownloadProgressFoundHashSeq":
        return _UniffiConverterTypeDownloadProgressFoundHashSeq.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_downloadprogress_as_found_hash_seq,self._pointer,)
        )






    def as_network_done(self, ) -> "DownloadProgressNetworkDone":
        return _UniffiConverterTypeDownloadProgressNetworkDone.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_downloadprogress_as_network_done,self._pointer,)
        )






    def as_progress(self, ) -> "DownloadProgressProgress":
        return _UniffiConverterTypeDownloadProgressProgress.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_downloadprogress_as_progress,self._pointer,)
        )






    def type(self, ) -> "DownloadProgressType":
        return _UniffiConverterTypeDownloadProgressType.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_downloadprogress_type,self._pointer,)
        )






class _UniffiConverterTypeDownloadProgress:
    @classmethod
    def read(cls, buf):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value, buf):
        if not isinstance(value, DownloadProgress):
            raise TypeError("Expected DownloadProgress instance, {} found".format(type(value).__name__))
        buf.write_u64(cls.lower(value))

    @staticmethod
    def lift(value):
        return DownloadProgress._make_instance_(value)

    @staticmethod
    def lower(value):
        return value._pointer



class Entry:
    _pointer: ctypes.c_void_p

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_iroh_fn_free_entry, pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst


    def author(self, ) -> "AuthorId":
        return _UniffiConverterTypeAuthorId.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_entry_author,self._pointer,)
        )






    def content_hash(self, ) -> "Hash":
        return _UniffiConverterTypeHash.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_entry_content_hash,self._pointer,)
        )






    def content_len(self, ) -> "int":
        return _UniffiConverterUInt64.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_entry_content_len,self._pointer,)
        )






    def key(self, ) -> "bytes":
        return _UniffiConverterBytes.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_entry_key,self._pointer,)
        )






    def namespace(self, ) -> "NamespaceId":
        return _UniffiConverterTypeNamespaceId.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_entry_namespace,self._pointer,)
        )






class _UniffiConverterTypeEntry:
    @classmethod
    def read(cls, buf):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value, buf):
        if not isinstance(value, Entry):
            raise TypeError("Expected Entry instance, {} found".format(type(value).__name__))
        buf.write_u64(cls.lower(value))

    @staticmethod
    def lift(value):
        return Entry._make_instance_(value)

    @staticmethod
    def lower(value):
        return value._pointer



class Hash:
    _pointer: ctypes.c_void_p
    def __init__(self, buf: "bytes"):
        
        self._pointer = _rust_call(_UniffiLib.uniffi_iroh_fn_constructor_hash_new,
        _UniffiConverterBytes.lower(buf))

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_iroh_fn_free_hash, pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst

    @classmethod
    def from_bytes(cls, bytes: "bytes"):
        
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call_with_error(_UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_constructor_hash_from_bytes,
        _UniffiConverterBytes.lower(bytes))
        return cls._make_instance_(pointer)


    @classmethod
    def from_cid_bytes(cls, bytes: "bytes"):
        
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call_with_error(_UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_constructor_hash_from_cid_bytes,
        _UniffiConverterBytes.lower(bytes))
        return cls._make_instance_(pointer)


    @classmethod
    def from_string(cls, str: "str"):
        
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call_with_error(_UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_constructor_hash_from_string,
        _UniffiConverterString.lower(str))
        return cls._make_instance_(pointer)



    def as_cid_bytes(self, ) -> "bytes":
        return _UniffiConverterBytes.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_hash_as_cid_bytes,self._pointer,)
        )






    def equal(self, other: "Hash") -> "bool":
        
        return _UniffiConverterBool.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_hash_equal,self._pointer,
        _UniffiConverterTypeHash.lower(other))
        )






    def to_bytes(self, ) -> "bytes":
        return _UniffiConverterBytes.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_hash_to_bytes,self._pointer,)
        )






    def to_hex(self, ) -> "str":
        return _UniffiConverterString.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_hash_to_hex,self._pointer,)
        )






    def to_string(self, ) -> "str":
        return _UniffiConverterString.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_hash_to_string,self._pointer,)
        )






class _UniffiConverterTypeHash:
    @classmethod
    def read(cls, buf):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value, buf):
        if not isinstance(value, Hash):
            raise TypeError("Expected Hash instance, {} found".format(type(value).__name__))
        buf.write_u64(cls.lower(value))

    @staticmethod
    def lift(value):
        return Hash._make_instance_(value)

    @staticmethod
    def lower(value):
        return value._pointer



class Ipv4Addr:
    _pointer: ctypes.c_void_p
    def __init__(self, a: "int",b: "int",c: "int",d: "int"):
        
        
        
        
        self._pointer = _rust_call(_UniffiLib.uniffi_iroh_fn_constructor_ipv4addr_new,
        _UniffiConverterUInt8.lower(a),
        _UniffiConverterUInt8.lower(b),
        _UniffiConverterUInt8.lower(c),
        _UniffiConverterUInt8.lower(d))

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_iroh_fn_free_ipv4addr, pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst

    @classmethod
    def from_string(cls, str: "str"):
        
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call_with_error(_UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_constructor_ipv4addr_from_string,
        _UniffiConverterString.lower(str))
        return cls._make_instance_(pointer)



    def equal(self, other: "Ipv4Addr") -> "bool":
        
        return _UniffiConverterBool.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_ipv4addr_equal,self._pointer,
        _UniffiConverterTypeIpv4Addr.lower(other))
        )






    def octets(self, ) -> "typing.List[int]":
        return _UniffiConverterSequenceUInt8.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_ipv4addr_octets,self._pointer,)
        )






    def to_string(self, ) -> "str":
        return _UniffiConverterString.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_ipv4addr_to_string,self._pointer,)
        )






class _UniffiConverterTypeIpv4Addr:
    @classmethod
    def read(cls, buf):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value, buf):
        if not isinstance(value, Ipv4Addr):
            raise TypeError("Expected Ipv4Addr instance, {} found".format(type(value).__name__))
        buf.write_u64(cls.lower(value))

    @staticmethod
    def lift(value):
        return Ipv4Addr._make_instance_(value)

    @staticmethod
    def lower(value):
        return value._pointer



class Ipv6Addr:
    _pointer: ctypes.c_void_p
    def __init__(self, a: "int",b: "int",c: "int",d: "int",e: "int",f: "int",g: "int",h: "int"):
        
        
        
        
        
        
        
        
        self._pointer = _rust_call(_UniffiLib.uniffi_iroh_fn_constructor_ipv6addr_new,
        _UniffiConverterUInt16.lower(a),
        _UniffiConverterUInt16.lower(b),
        _UniffiConverterUInt16.lower(c),
        _UniffiConverterUInt16.lower(d),
        _UniffiConverterUInt16.lower(e),
        _UniffiConverterUInt16.lower(f),
        _UniffiConverterUInt16.lower(g),
        _UniffiConverterUInt16.lower(h))

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_iroh_fn_free_ipv6addr, pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst

    @classmethod
    def from_string(cls, str: "str"):
        
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call_with_error(_UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_constructor_ipv6addr_from_string,
        _UniffiConverterString.lower(str))
        return cls._make_instance_(pointer)



    def equal(self, other: "Ipv6Addr") -> "bool":
        
        return _UniffiConverterBool.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_ipv6addr_equal,self._pointer,
        _UniffiConverterTypeIpv6Addr.lower(other))
        )






    def segments(self, ) -> "typing.List[int]":
        return _UniffiConverterSequenceUInt16.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_ipv6addr_segments,self._pointer,)
        )






    def to_string(self, ) -> "str":
        return _UniffiConverterString.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_ipv6addr_to_string,self._pointer,)
        )






class _UniffiConverterTypeIpv6Addr:
    @classmethod
    def read(cls, buf):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value, buf):
        if not isinstance(value, Ipv6Addr):
            raise TypeError("Expected Ipv6Addr instance, {} found".format(type(value).__name__))
        buf.write_u64(cls.lower(value))

    @staticmethod
    def lift(value):
        return Ipv6Addr._make_instance_(value)

    @staticmethod
    def lower(value):
        return value._pointer



class IrohNode:
    _pointer: ctypes.c_void_p
    def __init__(self, path: "str"):
        
        self._pointer = _rust_call_with_error(_UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_constructor_irohnode_new,
        _UniffiConverterString.lower(path))

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_iroh_fn_free_irohnode, pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst


    def author_create(self, ) -> "AuthorId":
        return _UniffiConverterTypeAuthorId.lift(
            _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_irohnode_author_create,self._pointer,)
        )






    def author_list(self, ) -> "typing.List[AuthorId]":
        return _UniffiConverterSequenceTypeAuthorId.lift(
            _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_irohnode_author_list,self._pointer,)
        )






    def blobs_add_bytes(self, bytes: "bytes",tag: "SetTagOption") -> "BlobAddOutcome":
        
        
        return _UniffiConverterTypeBlobAddOutcome.lift(
            _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_add_bytes,self._pointer,
        _UniffiConverterBytes.lower(bytes),
        _UniffiConverterTypeSetTagOption.lower(tag))
        )






    def blobs_add_from_path(self, path: "str",in_place: "bool",tag: "SetTagOption",wrap: "WrapOption",cb: "AddCallback"):
        
        
        
        
        
        _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_add_from_path,self._pointer,
        _UniffiConverterString.lower(path),
        _UniffiConverterBool.lower(in_place),
        _UniffiConverterTypeSetTagOption.lower(tag),
        _UniffiConverterTypeWrapOption.lower(wrap),
        _UniffiConverterCallbackInterfaceAddCallback.lower(cb))







    def blobs_delete_blob(self, hash: "Hash"):
        
        _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_delete_blob,self._pointer,
        _UniffiConverterTypeHash.lower(hash))







    def blobs_download(self, req: "BlobDownloadRequest",cb: "DownloadCallback"):
        
        
        _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_download,self._pointer,
        _UniffiConverterTypeBlobDownloadRequest.lower(req),
        _UniffiConverterCallbackInterfaceDownloadCallback.lower(cb))







    def blobs_list(self, ) -> "typing.List[Hash]":
        return _UniffiConverterSequenceTypeHash.lift(
            _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_list,self._pointer,)
        )






    def blobs_list_collections(self, ) -> "typing.List[BlobListCollectionsResponse]":
        return _UniffiConverterSequenceTypeBlobListCollectionsResponse.lift(
            _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_list_collections,self._pointer,)
        )






    def blobs_list_incomplete(self, ) -> "typing.List[BlobListIncompleteResponse]":
        return _UniffiConverterSequenceTypeBlobListIncompleteResponse.lift(
            _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_list_incomplete,self._pointer,)
        )






    def blobs_read_to_bytes(self, hash: "Hash") -> "bytes":
        
        return _UniffiConverterBytes.lift(
            _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_read_to_bytes,self._pointer,
        _UniffiConverterTypeHash.lower(hash))
        )






    def blobs_size(self, hash: "Hash") -> "int":
        
        return _UniffiConverterUInt64.lift(
            _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_size,self._pointer,
        _UniffiConverterTypeHash.lower(hash))
        )






    def blobs_write_to_path(self, hash: "Hash",path: "str"):
        
        
        _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_irohnode_blobs_write_to_path,self._pointer,
        _UniffiConverterTypeHash.lower(hash),
        _UniffiConverterString.lower(path))







    def connection_info(self, node_id: "PublicKey") -> "typing.Optional[ConnectionInfo]":
        
        return _UniffiConverterOptionalTypeConnectionInfo.lift(
            _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_irohnode_connection_info,self._pointer,
        _UniffiConverterTypePublicKey.lower(node_id))
        )






    def connections(self, ) -> "typing.List[ConnectionInfo]":
        return _UniffiConverterSequenceTypeConnectionInfo.lift(
            _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_irohnode_connections,self._pointer,)
        )






    def doc_create(self, ) -> "Doc":
        return _UniffiConverterTypeDoc.lift(
            _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_irohnode_doc_create,self._pointer,)
        )






    def doc_join(self, ticket: "DocTicket") -> "Doc":
        
        return _UniffiConverterTypeDoc.lift(
            _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_irohnode_doc_join,self._pointer,
        _UniffiConverterTypeDocTicket.lower(ticket))
        )






    def doc_list(self, ) -> "typing.List[NamespaceAndCapability]":
        return _UniffiConverterSequenceTypeNamespaceAndCapability.lift(
            _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_irohnode_doc_list,self._pointer,)
        )






    def node_id(self, ) -> "str":
        return _UniffiConverterString.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_irohnode_node_id,self._pointer,)
        )






    def stats(self, ) -> "dict":
        return _UniffiConverterMapStringTypeCounterStats.lift(
            _rust_call_with_error(
    _UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_method_irohnode_stats,self._pointer,)
        )






class _UniffiConverterTypeIrohNode:
    @classmethod
    def read(cls, buf):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value, buf):
        if not isinstance(value, IrohNode):
            raise TypeError("Expected IrohNode instance, {} found".format(type(value).__name__))
        buf.write_u64(cls.lower(value))

    @staticmethod
    def lift(value):
        return IrohNode._make_instance_(value)

    @staticmethod
    def lower(value):
        return value._pointer



class LiveEvent:
    _pointer: ctypes.c_void_p

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_iroh_fn_free_liveevent, pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst


    def as_content_ready(self, ) -> "Hash":
        return _UniffiConverterTypeHash.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_liveevent_as_content_ready,self._pointer,)
        )






    def as_insert_local(self, ) -> "Entry":
        return _UniffiConverterTypeEntry.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_liveevent_as_insert_local,self._pointer,)
        )






    def as_insert_remote(self, ) -> "InsertRemoteEvent":
        return _UniffiConverterTypeInsertRemoteEvent.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_liveevent_as_insert_remote,self._pointer,)
        )






    def as_neighbor_down(self, ) -> "PublicKey":
        return _UniffiConverterTypePublicKey.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_liveevent_as_neighbor_down,self._pointer,)
        )






    def as_neighbor_up(self, ) -> "PublicKey":
        return _UniffiConverterTypePublicKey.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_liveevent_as_neighbor_up,self._pointer,)
        )






    def as_sync_finished(self, ) -> "SyncEvent":
        return _UniffiConverterTypeSyncEvent.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_liveevent_as_sync_finished,self._pointer,)
        )






    def type(self, ) -> "LiveEventType":
        return _UniffiConverterTypeLiveEventType.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_liveevent_type,self._pointer,)
        )






class _UniffiConverterTypeLiveEvent:
    @classmethod
    def read(cls, buf):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value, buf):
        if not isinstance(value, LiveEvent):
            raise TypeError("Expected LiveEvent instance, {} found".format(type(value).__name__))
        buf.write_u64(cls.lower(value))

    @staticmethod
    def lift(value):
        return LiveEvent._make_instance_(value)

    @staticmethod
    def lower(value):
        return value._pointer



class NamespaceId:
    _pointer: ctypes.c_void_p

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_iroh_fn_free_namespaceid, pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst

    @classmethod
    def from_string(cls, str: "str"):
        
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call_with_error(_UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_constructor_namespaceid_from_string,
        _UniffiConverterString.lower(str))
        return cls._make_instance_(pointer)



    def equal(self, other: "NamespaceId") -> "bool":
        
        return _UniffiConverterBool.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_namespaceid_equal,self._pointer,
        _UniffiConverterTypeNamespaceId.lower(other))
        )






    def to_string(self, ) -> "str":
        return _UniffiConverterString.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_namespaceid_to_string,self._pointer,)
        )






class _UniffiConverterTypeNamespaceId:
    @classmethod
    def read(cls, buf):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value, buf):
        if not isinstance(value, NamespaceId):
            raise TypeError("Expected NamespaceId instance, {} found".format(type(value).__name__))
        buf.write_u64(cls.lower(value))

    @staticmethod
    def lift(value):
        return NamespaceId._make_instance_(value)

    @staticmethod
    def lower(value):
        return value._pointer



class NodeAddr:
    _pointer: ctypes.c_void_p
    def __init__(self, node_id: "PublicKey",region_id: "typing.Optional[int]",addresses: "typing.List[SocketAddr]"):
        
        
        
        self._pointer = _rust_call(_UniffiLib.uniffi_iroh_fn_constructor_nodeaddr_new,
        _UniffiConverterTypePublicKey.lower(node_id),
        _UniffiConverterOptionalUInt16.lower(region_id),
        _UniffiConverterSequenceTypeSocketAddr.lower(addresses))

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_iroh_fn_free_nodeaddr, pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst


    def derp_region(self, ) -> "typing.Optional[int]":
        return _UniffiConverterOptionalUInt16.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_nodeaddr_derp_region,self._pointer,)
        )






    def direct_addresses(self, ) -> "typing.List[SocketAddr]":
        return _UniffiConverterSequenceTypeSocketAddr.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_nodeaddr_direct_addresses,self._pointer,)
        )






    def equal(self, other: "NodeAddr") -> "bool":
        
        return _UniffiConverterBool.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_nodeaddr_equal,self._pointer,
        _UniffiConverterTypeNodeAddr.lower(other))
        )






class _UniffiConverterTypeNodeAddr:
    @classmethod
    def read(cls, buf):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value, buf):
        if not isinstance(value, NodeAddr):
            raise TypeError("Expected NodeAddr instance, {} found".format(type(value).__name__))
        buf.write_u64(cls.lower(value))

    @staticmethod
    def lift(value):
        return NodeAddr._make_instance_(value)

    @staticmethod
    def lower(value):
        return value._pointer



class PublicKey:
    _pointer: ctypes.c_void_p

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_iroh_fn_free_publickey, pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst

    @classmethod
    def from_bytes(cls, bytes: "bytes"):
        
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call_with_error(_UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_constructor_publickey_from_bytes,
        _UniffiConverterBytes.lower(bytes))
        return cls._make_instance_(pointer)


    @classmethod
    def from_string(cls, s: "str"):
        
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call_with_error(_UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_constructor_publickey_from_string,
        _UniffiConverterString.lower(s))
        return cls._make_instance_(pointer)



    def equal(self, other: "PublicKey") -> "bool":
        
        return _UniffiConverterBool.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_publickey_equal,self._pointer,
        _UniffiConverterTypePublicKey.lower(other))
        )






    def fmt_short(self, ) -> "str":
        return _UniffiConverterString.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_publickey_fmt_short,self._pointer,)
        )






    def to_bytes(self, ) -> "bytes":
        return _UniffiConverterBytes.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_publickey_to_bytes,self._pointer,)
        )






    def to_string(self, ) -> "str":
        return _UniffiConverterString.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_publickey_to_string,self._pointer,)
        )






class _UniffiConverterTypePublicKey:
    @classmethod
    def read(cls, buf):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value, buf):
        if not isinstance(value, PublicKey):
            raise TypeError("Expected PublicKey instance, {} found".format(type(value).__name__))
        buf.write_u64(cls.lower(value))

    @staticmethod
    def lift(value):
        return PublicKey._make_instance_(value)

    @staticmethod
    def lower(value):
        return value._pointer



class Query:
    _pointer: ctypes.c_void_p

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_iroh_fn_free_query, pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst

    @classmethod
    def all(cls, opts: "typing.Optional[QueryOptions]"):
        
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call(_UniffiLib.uniffi_iroh_fn_constructor_query_all,
        _UniffiConverterOptionalTypeQueryOptions.lower(opts))
        return cls._make_instance_(pointer)


    @classmethod
    def author(cls, author: "AuthorId",opts: "typing.Optional[QueryOptions]"):
        
        
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call(_UniffiLib.uniffi_iroh_fn_constructor_query_author,
        _UniffiConverterTypeAuthorId.lower(author),
        _UniffiConverterOptionalTypeQueryOptions.lower(opts))
        return cls._make_instance_(pointer)


    @classmethod
    def author_key_exact(cls, author: "AuthorId",key: "bytes"):
        
        
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call(_UniffiLib.uniffi_iroh_fn_constructor_query_author_key_exact,
        _UniffiConverterTypeAuthorId.lower(author),
        _UniffiConverterBytes.lower(key))
        return cls._make_instance_(pointer)


    @classmethod
    def author_key_prefix(cls, author: "AuthorId",prefix: "bytes",opts: "typing.Optional[QueryOptions]"):
        
        
        
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call(_UniffiLib.uniffi_iroh_fn_constructor_query_author_key_prefix,
        _UniffiConverterTypeAuthorId.lower(author),
        _UniffiConverterBytes.lower(prefix),
        _UniffiConverterOptionalTypeQueryOptions.lower(opts))
        return cls._make_instance_(pointer)


    @classmethod
    def key_exact(cls, key: "bytes",opts: "typing.Optional[QueryOptions]"):
        
        
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call(_UniffiLib.uniffi_iroh_fn_constructor_query_key_exact,
        _UniffiConverterBytes.lower(key),
        _UniffiConverterOptionalTypeQueryOptions.lower(opts))
        return cls._make_instance_(pointer)


    @classmethod
    def key_prefix(cls, prefix: "bytes",opts: "typing.Optional[QueryOptions]"):
        
        
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call(_UniffiLib.uniffi_iroh_fn_constructor_query_key_prefix,
        _UniffiConverterBytes.lower(prefix),
        _UniffiConverterOptionalTypeQueryOptions.lower(opts))
        return cls._make_instance_(pointer)


    @classmethod
    def single_latest_per_key(cls, opts: "typing.Optional[QueryOptions]"):
        
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call(_UniffiLib.uniffi_iroh_fn_constructor_query_single_latest_per_key,
        _UniffiConverterOptionalTypeQueryOptions.lower(opts))
        return cls._make_instance_(pointer)



    def limit(self, ) -> "typing.Optional[int]":
        return _UniffiConverterOptionalUInt64.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_query_limit,self._pointer,)
        )






    def offset(self, ) -> "int":
        return _UniffiConverterUInt64.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_query_offset,self._pointer,)
        )






class _UniffiConverterTypeQuery:
    @classmethod
    def read(cls, buf):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value, buf):
        if not isinstance(value, Query):
            raise TypeError("Expected Query instance, {} found".format(type(value).__name__))
        buf.write_u64(cls.lower(value))

    @staticmethod
    def lift(value):
        return Query._make_instance_(value)

    @staticmethod
    def lower(value):
        return value._pointer



class RequestToken:
    _pointer: ctypes.c_void_p
    def __init__(self, bytes: "bytes"):
        
        self._pointer = _rust_call_with_error(_UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_constructor_requesttoken_new,
        _UniffiConverterBytes.lower(bytes))

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_iroh_fn_free_requesttoken, pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst

    @classmethod
    def from_string(cls, str: "str"):
        
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call_with_error(_UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_constructor_requesttoken_from_string,
        _UniffiConverterString.lower(str))
        return cls._make_instance_(pointer)


    @classmethod
    def generate(cls, ):
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call(_UniffiLib.uniffi_iroh_fn_constructor_requesttoken_generate,)
        return cls._make_instance_(pointer)



    def as_bytes(self, ) -> "bytes":
        return _UniffiConverterBytes.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_requesttoken_as_bytes,self._pointer,)
        )






    def equal(self, other: "RequestToken") -> "bool":
        
        return _UniffiConverterBool.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_requesttoken_equal,self._pointer,
        _UniffiConverterTypeRequestToken.lower(other))
        )






class _UniffiConverterTypeRequestToken:
    @classmethod
    def read(cls, buf):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value, buf):
        if not isinstance(value, RequestToken):
            raise TypeError("Expected RequestToken instance, {} found".format(type(value).__name__))
        buf.write_u64(cls.lower(value))

    @staticmethod
    def lift(value):
        return RequestToken._make_instance_(value)

    @staticmethod
    def lower(value):
        return value._pointer



class SetTagOption:
    _pointer: ctypes.c_void_p

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_iroh_fn_free_settagoption, pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst

    @classmethod
    def auto(cls, ):
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call(_UniffiLib.uniffi_iroh_fn_constructor_settagoption_auto,)
        return cls._make_instance_(pointer)


    @classmethod
    def named(cls, tag: "Tag"):
        
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call(_UniffiLib.uniffi_iroh_fn_constructor_settagoption_named,
        _UniffiConverterTypeTag.lower(tag))
        return cls._make_instance_(pointer)



class _UniffiConverterTypeSetTagOption:
    @classmethod
    def read(cls, buf):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value, buf):
        if not isinstance(value, SetTagOption):
            raise TypeError("Expected SetTagOption instance, {} found".format(type(value).__name__))
        buf.write_u64(cls.lower(value))

    @staticmethod
    def lift(value):
        return SetTagOption._make_instance_(value)

    @staticmethod
    def lower(value):
        return value._pointer



class SocketAddr:
    _pointer: ctypes.c_void_p

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_iroh_fn_free_socketaddr, pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst

    @classmethod
    def from_ipv4(cls, ipv4: "Ipv4Addr",port: "int"):
        
        
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call(_UniffiLib.uniffi_iroh_fn_constructor_socketaddr_from_ipv4,
        _UniffiConverterTypeIpv4Addr.lower(ipv4),
        _UniffiConverterUInt16.lower(port))
        return cls._make_instance_(pointer)


    @classmethod
    def from_ipv6(cls, ipv6: "Ipv6Addr",port: "int"):
        
        
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call(_UniffiLib.uniffi_iroh_fn_constructor_socketaddr_from_ipv6,
        _UniffiConverterTypeIpv6Addr.lower(ipv6),
        _UniffiConverterUInt16.lower(port))
        return cls._make_instance_(pointer)



    def as_ipv4(self, ) -> "SocketAddrV4":
        return _UniffiConverterTypeSocketAddrV4.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_socketaddr_as_ipv4,self._pointer,)
        )






    def as_ipv6(self, ) -> "SocketAddrV6":
        return _UniffiConverterTypeSocketAddrV6.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_socketaddr_as_ipv6,self._pointer,)
        )






    def equal(self, other: "SocketAddr") -> "bool":
        
        return _UniffiConverterBool.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_socketaddr_equal,self._pointer,
        _UniffiConverterTypeSocketAddr.lower(other))
        )






    def type(self, ) -> "SocketAddrType":
        return _UniffiConverterTypeSocketAddrType.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_socketaddr_type,self._pointer,)
        )






class _UniffiConverterTypeSocketAddr:
    @classmethod
    def read(cls, buf):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value, buf):
        if not isinstance(value, SocketAddr):
            raise TypeError("Expected SocketAddr instance, {} found".format(type(value).__name__))
        buf.write_u64(cls.lower(value))

    @staticmethod
    def lift(value):
        return SocketAddr._make_instance_(value)

    @staticmethod
    def lower(value):
        return value._pointer



class SocketAddrV4:
    _pointer: ctypes.c_void_p
    def __init__(self, ipv4: "Ipv4Addr",port: "int"):
        
        
        self._pointer = _rust_call(_UniffiLib.uniffi_iroh_fn_constructor_socketaddrv4_new,
        _UniffiConverterTypeIpv4Addr.lower(ipv4),
        _UniffiConverterUInt16.lower(port))

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_iroh_fn_free_socketaddrv4, pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst

    @classmethod
    def from_string(cls, str: "str"):
        
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call_with_error(_UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_constructor_socketaddrv4_from_string,
        _UniffiConverterString.lower(str))
        return cls._make_instance_(pointer)



    def equal(self, other: "SocketAddrV4") -> "bool":
        
        return _UniffiConverterBool.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_socketaddrv4_equal,self._pointer,
        _UniffiConverterTypeSocketAddrV4.lower(other))
        )






    def ip(self, ) -> "Ipv4Addr":
        return _UniffiConverterTypeIpv4Addr.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_socketaddrv4_ip,self._pointer,)
        )






    def port(self, ) -> "int":
        return _UniffiConverterUInt16.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_socketaddrv4_port,self._pointer,)
        )






    def to_string(self, ) -> "str":
        return _UniffiConverterString.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_socketaddrv4_to_string,self._pointer,)
        )






class _UniffiConverterTypeSocketAddrV4:
    @classmethod
    def read(cls, buf):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value, buf):
        if not isinstance(value, SocketAddrV4):
            raise TypeError("Expected SocketAddrV4 instance, {} found".format(type(value).__name__))
        buf.write_u64(cls.lower(value))

    @staticmethod
    def lift(value):
        return SocketAddrV4._make_instance_(value)

    @staticmethod
    def lower(value):
        return value._pointer



class SocketAddrV6:
    _pointer: ctypes.c_void_p
    def __init__(self, ipv6: "Ipv6Addr",port: "int"):
        
        
        self._pointer = _rust_call(_UniffiLib.uniffi_iroh_fn_constructor_socketaddrv6_new,
        _UniffiConverterTypeIpv6Addr.lower(ipv6),
        _UniffiConverterUInt16.lower(port))

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_iroh_fn_free_socketaddrv6, pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst

    @classmethod
    def from_string(cls, str: "str"):
        
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call_with_error(_UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_constructor_socketaddrv6_from_string,
        _UniffiConverterString.lower(str))
        return cls._make_instance_(pointer)



    def equal(self, other: "SocketAddrV6") -> "bool":
        
        return _UniffiConverterBool.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_socketaddrv6_equal,self._pointer,
        _UniffiConverterTypeSocketAddrV6.lower(other))
        )






    def ip(self, ) -> "Ipv6Addr":
        return _UniffiConverterTypeIpv6Addr.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_socketaddrv6_ip,self._pointer,)
        )






    def port(self, ) -> "int":
        return _UniffiConverterUInt16.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_socketaddrv6_port,self._pointer,)
        )






    def to_string(self, ) -> "str":
        return _UniffiConverterString.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_socketaddrv6_to_string,self._pointer,)
        )






class _UniffiConverterTypeSocketAddrV6:
    @classmethod
    def read(cls, buf):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value, buf):
        if not isinstance(value, SocketAddrV6):
            raise TypeError("Expected SocketAddrV6 instance, {} found".format(type(value).__name__))
        buf.write_u64(cls.lower(value))

    @staticmethod
    def lift(value):
        return SocketAddrV6._make_instance_(value)

    @staticmethod
    def lower(value):
        return value._pointer



class Tag:
    _pointer: ctypes.c_void_p

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_iroh_fn_free_tag, pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst

    @classmethod
    def from_bytes(cls, bytes: "bytes"):
        
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call(_UniffiLib.uniffi_iroh_fn_constructor_tag_from_bytes,
        _UniffiConverterBytes.lower(bytes))
        return cls._make_instance_(pointer)


    @classmethod
    def from_string(cls, s: "str"):
        
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call(_UniffiLib.uniffi_iroh_fn_constructor_tag_from_string,
        _UniffiConverterString.lower(s))
        return cls._make_instance_(pointer)



    def equal(self, other: "Tag") -> "bool":
        
        return _UniffiConverterBool.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_tag_equal,self._pointer,
        _UniffiConverterTypeTag.lower(other))
        )






    def to_bytes(self, ) -> "bytes":
        return _UniffiConverterBytes.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_tag_to_bytes,self._pointer,)
        )






    def to_string(self, ) -> "str":
        return _UniffiConverterString.lift(
            _rust_call(_UniffiLib.uniffi_iroh_fn_method_tag_to_string,self._pointer,)
        )






class _UniffiConverterTypeTag:
    @classmethod
    def read(cls, buf):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value, buf):
        if not isinstance(value, Tag):
            raise TypeError("Expected Tag instance, {} found".format(type(value).__name__))
        buf.write_u64(cls.lower(value))

    @staticmethod
    def lift(value):
        return Tag._make_instance_(value)

    @staticmethod
    def lower(value):
        return value._pointer



class WrapOption:
    _pointer: ctypes.c_void_p

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_iroh_fn_free_wrapoption, pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst

    @classmethod
    def no_wrap(cls, ):
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call(_UniffiLib.uniffi_iroh_fn_constructor_wrapoption_no_wrap,)
        return cls._make_instance_(pointer)


    @classmethod
    def wrap(cls, name: "typing.Optional[str]"):
        
        # Call the (fallible) function before creating any half-baked object instances.
        pointer = _rust_call(_UniffiLib.uniffi_iroh_fn_constructor_wrapoption_wrap,
        _UniffiConverterOptionalString.lower(name))
        return cls._make_instance_(pointer)



class _UniffiConverterTypeWrapOption:
    @classmethod
    def read(cls, buf):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value, buf):
        if not isinstance(value, WrapOption):
            raise TypeError("Expected WrapOption instance, {} found".format(type(value).__name__))
        buf.write_u64(cls.lower(value))

    @staticmethod
    def lift(value):
        return WrapOption._make_instance_(value)

    @staticmethod
    def lower(value):
        return value._pointer


class AddProgressAbort:
    error: "str";

    @typing.no_type_check
    def __init__(self, error: "str"):
        self.error = error

    def __str__(self):
        return "AddProgressAbort(error={})".format(self.error)

    def __eq__(self, other):
        if self.error != other.error:
            return False
        return True

class _UniffiConverterTypeAddProgressAbort(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return AddProgressAbort(
            error=_UniffiConverterString.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterString.write(value.error, buf)


class AddProgressAllDone:
    hash: "Hash";format: "BlobFormat";tag: "Tag";

    @typing.no_type_check
    def __init__(self, hash: "Hash", format: "BlobFormat", tag: "Tag"):
        self.hash = hash
        self.format = format
        self.tag = tag

    def __str__(self):
        return "AddProgressAllDone(hash={}, format={}, tag={})".format(self.hash, self.format, self.tag)

    def __eq__(self, other):
        if self.hash != other.hash:
            return False
        if self.format != other.format:
            return False
        if self.tag != other.tag:
            return False
        return True

class _UniffiConverterTypeAddProgressAllDone(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return AddProgressAllDone(
            hash=_UniffiConverterTypeHash.read(buf),
            format=_UniffiConverterTypeBlobFormat.read(buf),
            tag=_UniffiConverterTypeTag.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterTypeHash.write(value.hash, buf)
        _UniffiConverterTypeBlobFormat.write(value.format, buf)
        _UniffiConverterTypeTag.write(value.tag, buf)


class AddProgressDone:
    id: "int";hash: "Hash";

    @typing.no_type_check
    def __init__(self, id: "int", hash: "Hash"):
        self.id = id
        self.hash = hash

    def __str__(self):
        return "AddProgressDone(id={}, hash={})".format(self.id, self.hash)

    def __eq__(self, other):
        if self.id != other.id:
            return False
        if self.hash != other.hash:
            return False
        return True

class _UniffiConverterTypeAddProgressDone(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return AddProgressDone(
            id=_UniffiConverterUInt64.read(buf),
            hash=_UniffiConverterTypeHash.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterUInt64.write(value.id, buf)
        _UniffiConverterTypeHash.write(value.hash, buf)


class AddProgressFound:
    id: "int";name: "str";size: "int";

    @typing.no_type_check
    def __init__(self, id: "int", name: "str", size: "int"):
        self.id = id
        self.name = name
        self.size = size

    def __str__(self):
        return "AddProgressFound(id={}, name={}, size={})".format(self.id, self.name, self.size)

    def __eq__(self, other):
        if self.id != other.id:
            return False
        if self.name != other.name:
            return False
        if self.size != other.size:
            return False
        return True

class _UniffiConverterTypeAddProgressFound(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return AddProgressFound(
            id=_UniffiConverterUInt64.read(buf),
            name=_UniffiConverterString.read(buf),
            size=_UniffiConverterUInt64.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterUInt64.write(value.id, buf)
        _UniffiConverterString.write(value.name, buf)
        _UniffiConverterUInt64.write(value.size, buf)


class AddProgressProgress:
    id: "int";offset: "int";

    @typing.no_type_check
    def __init__(self, id: "int", offset: "int"):
        self.id = id
        self.offset = offset

    def __str__(self):
        return "AddProgressProgress(id={}, offset={})".format(self.id, self.offset)

    def __eq__(self, other):
        if self.id != other.id:
            return False
        if self.offset != other.offset:
            return False
        return True

class _UniffiConverterTypeAddProgressProgress(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return AddProgressProgress(
            id=_UniffiConverterUInt64.read(buf),
            offset=_UniffiConverterUInt64.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterUInt64.write(value.id, buf)
        _UniffiConverterUInt64.write(value.offset, buf)


class BlobAddOutcome:
    hash: "Hash";format: "BlobFormat";size: "int";tag: "Tag";

    @typing.no_type_check
    def __init__(self, hash: "Hash", format: "BlobFormat", size: "int", tag: "Tag"):
        self.hash = hash
        self.format = format
        self.size = size
        self.tag = tag

    def __str__(self):
        return "BlobAddOutcome(hash={}, format={}, size={}, tag={})".format(self.hash, self.format, self.size, self.tag)

    def __eq__(self, other):
        if self.hash != other.hash:
            return False
        if self.format != other.format:
            return False
        if self.size != other.size:
            return False
        if self.tag != other.tag:
            return False
        return True

class _UniffiConverterTypeBlobAddOutcome(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return BlobAddOutcome(
            hash=_UniffiConverterTypeHash.read(buf),
            format=_UniffiConverterTypeBlobFormat.read(buf),
            size=_UniffiConverterUInt64.read(buf),
            tag=_UniffiConverterTypeTag.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterTypeHash.write(value.hash, buf)
        _UniffiConverterTypeBlobFormat.write(value.format, buf)
        _UniffiConverterUInt64.write(value.size, buf)
        _UniffiConverterTypeTag.write(value.tag, buf)


class BlobListCollectionsResponse:
    tag: "Tag";hash: "Hash";total_blobs_count: "typing.Optional[int]";total_blobs_size: "typing.Optional[int]";

    @typing.no_type_check
    def __init__(self, tag: "Tag", hash: "Hash", total_blobs_count: "typing.Optional[int]", total_blobs_size: "typing.Optional[int]"):
        self.tag = tag
        self.hash = hash
        self.total_blobs_count = total_blobs_count
        self.total_blobs_size = total_blobs_size

    def __str__(self):
        return "BlobListCollectionsResponse(tag={}, hash={}, total_blobs_count={}, total_blobs_size={})".format(self.tag, self.hash, self.total_blobs_count, self.total_blobs_size)

    def __eq__(self, other):
        if self.tag != other.tag:
            return False
        if self.hash != other.hash:
            return False
        if self.total_blobs_count != other.total_blobs_count:
            return False
        if self.total_blobs_size != other.total_blobs_size:
            return False
        return True

class _UniffiConverterTypeBlobListCollectionsResponse(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return BlobListCollectionsResponse(
            tag=_UniffiConverterTypeTag.read(buf),
            hash=_UniffiConverterTypeHash.read(buf),
            total_blobs_count=_UniffiConverterOptionalUInt64.read(buf),
            total_blobs_size=_UniffiConverterOptionalUInt64.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterTypeTag.write(value.tag, buf)
        _UniffiConverterTypeHash.write(value.hash, buf)
        _UniffiConverterOptionalUInt64.write(value.total_blobs_count, buf)
        _UniffiConverterOptionalUInt64.write(value.total_blobs_size, buf)


class BlobListIncompleteResponse:
    size: "int";expected_size: "int";hash: "Hash";

    @typing.no_type_check
    def __init__(self, size: "int", expected_size: "int", hash: "Hash"):
        self.size = size
        self.expected_size = expected_size
        self.hash = hash

    def __str__(self):
        return "BlobListIncompleteResponse(size={}, expected_size={}, hash={})".format(self.size, self.expected_size, self.hash)

    def __eq__(self, other):
        if self.size != other.size:
            return False
        if self.expected_size != other.expected_size:
            return False
        if self.hash != other.hash:
            return False
        return True

class _UniffiConverterTypeBlobListIncompleteResponse(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return BlobListIncompleteResponse(
            size=_UniffiConverterUInt64.read(buf),
            expected_size=_UniffiConverterUInt64.read(buf),
            hash=_UniffiConverterTypeHash.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterUInt64.write(value.size, buf)
        _UniffiConverterUInt64.write(value.expected_size, buf)
        _UniffiConverterTypeHash.write(value.hash, buf)


class BlobListResponse:
    path: "str";hash: "Hash";size: "int";

    @typing.no_type_check
    def __init__(self, path: "str", hash: "Hash", size: "int"):
        self.path = path
        self.hash = hash
        self.size = size

    def __str__(self):
        return "BlobListResponse(path={}, hash={}, size={})".format(self.path, self.hash, self.size)

    def __eq__(self, other):
        if self.path != other.path:
            return False
        if self.hash != other.hash:
            return False
        if self.size != other.size:
            return False
        return True

class _UniffiConverterTypeBlobListResponse(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return BlobListResponse(
            path=_UniffiConverterString.read(buf),
            hash=_UniffiConverterTypeHash.read(buf),
            size=_UniffiConverterUInt64.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterString.write(value.path, buf)
        _UniffiConverterTypeHash.write(value.hash, buf)
        _UniffiConverterUInt64.write(value.size, buf)


class ConnectionInfo:
    public_key: "PublicKey";derp_region: "typing.Optional[int]";addrs: "typing.List[DirectAddrInfo]";conn_type: "ConnectionType";latency: "typing.Optional[Duration]";last_used: "typing.Optional[Duration]";

    @typing.no_type_check
    def __init__(self, public_key: "PublicKey", derp_region: "typing.Optional[int]", addrs: "typing.List[DirectAddrInfo]", conn_type: "ConnectionType", latency: "typing.Optional[Duration]", last_used: "typing.Optional[Duration]"):
        self.public_key = public_key
        self.derp_region = derp_region
        self.addrs = addrs
        self.conn_type = conn_type
        self.latency = latency
        self.last_used = last_used

    def __str__(self):
        return "ConnectionInfo(public_key={}, derp_region={}, addrs={}, conn_type={}, latency={}, last_used={})".format(self.public_key, self.derp_region, self.addrs, self.conn_type, self.latency, self.last_used)

    def __eq__(self, other):
        if self.public_key != other.public_key:
            return False
        if self.derp_region != other.derp_region:
            return False
        if self.addrs != other.addrs:
            return False
        if self.conn_type != other.conn_type:
            return False
        if self.latency != other.latency:
            return False
        if self.last_used != other.last_used:
            return False
        return True

class _UniffiConverterTypeConnectionInfo(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return ConnectionInfo(
            public_key=_UniffiConverterTypePublicKey.read(buf),
            derp_region=_UniffiConverterOptionalUInt16.read(buf),
            addrs=_UniffiConverterSequenceTypeDirectAddrInfo.read(buf),
            conn_type=_UniffiConverterTypeConnectionType.read(buf),
            latency=_UniffiConverterOptionalDuration.read(buf),
            last_used=_UniffiConverterOptionalDuration.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterTypePublicKey.write(value.public_key, buf)
        _UniffiConverterOptionalUInt16.write(value.derp_region, buf)
        _UniffiConverterSequenceTypeDirectAddrInfo.write(value.addrs, buf)
        _UniffiConverterTypeConnectionType.write(value.conn_type, buf)
        _UniffiConverterOptionalDuration.write(value.latency, buf)
        _UniffiConverterOptionalDuration.write(value.last_used, buf)


class CounterStats:
    value: "int";description: "str";

    @typing.no_type_check
    def __init__(self, value: "int", description: "str"):
        self.value = value
        self.description = description

    def __str__(self):
        return "CounterStats(value={}, description={})".format(self.value, self.description)

    def __eq__(self, other):
        if self.value != other.value:
            return False
        if self.description != other.description:
            return False
        return True

class _UniffiConverterTypeCounterStats(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return CounterStats(
            value=_UniffiConverterUInt64.read(buf),
            description=_UniffiConverterString.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterUInt64.write(value.value, buf)
        _UniffiConverterString.write(value.description, buf)


class DocExportProgressAbort:
    error: "str";

    @typing.no_type_check
    def __init__(self, error: "str"):
        self.error = error

    def __str__(self):
        return "DocExportProgressAbort(error={})".format(self.error)

    def __eq__(self, other):
        if self.error != other.error:
            return False
        return True

class _UniffiConverterTypeDocExportProgressAbort(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return DocExportProgressAbort(
            error=_UniffiConverterString.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterString.write(value.error, buf)


class DocExportProgressFound:
    id: "int";hash: "Hash";key: "bytes";size: "int";outpath: "str";

    @typing.no_type_check
    def __init__(self, id: "int", hash: "Hash", key: "bytes", size: "int", outpath: "str"):
        self.id = id
        self.hash = hash
        self.key = key
        self.size = size
        self.outpath = outpath

    def __str__(self):
        return "DocExportProgressFound(id={}, hash={}, key={}, size={}, outpath={})".format(self.id, self.hash, self.key, self.size, self.outpath)

    def __eq__(self, other):
        if self.id != other.id:
            return False
        if self.hash != other.hash:
            return False
        if self.key != other.key:
            return False
        if self.size != other.size:
            return False
        if self.outpath != other.outpath:
            return False
        return True

class _UniffiConverterTypeDocExportProgressFound(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return DocExportProgressFound(
            id=_UniffiConverterUInt64.read(buf),
            hash=_UniffiConverterTypeHash.read(buf),
            key=_UniffiConverterBytes.read(buf),
            size=_UniffiConverterUInt64.read(buf),
            outpath=_UniffiConverterString.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterUInt64.write(value.id, buf)
        _UniffiConverterTypeHash.write(value.hash, buf)
        _UniffiConverterBytes.write(value.key, buf)
        _UniffiConverterUInt64.write(value.size, buf)
        _UniffiConverterString.write(value.outpath, buf)


class DocExportProgressProgress:
    id: "int";offset: "int";

    @typing.no_type_check
    def __init__(self, id: "int", offset: "int"):
        self.id = id
        self.offset = offset

    def __str__(self):
        return "DocExportProgressProgress(id={}, offset={})".format(self.id, self.offset)

    def __eq__(self, other):
        if self.id != other.id:
            return False
        if self.offset != other.offset:
            return False
        return True

class _UniffiConverterTypeDocExportProgressProgress(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return DocExportProgressProgress(
            id=_UniffiConverterUInt64.read(buf),
            offset=_UniffiConverterUInt64.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterUInt64.write(value.id, buf)
        _UniffiConverterUInt64.write(value.offset, buf)


class DocImportProgressAbort:
    error: "str";

    @typing.no_type_check
    def __init__(self, error: "str"):
        self.error = error

    def __str__(self):
        return "DocImportProgressAbort(error={})".format(self.error)

    def __eq__(self, other):
        if self.error != other.error:
            return False
        return True

class _UniffiConverterTypeDocImportProgressAbort(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return DocImportProgressAbort(
            error=_UniffiConverterString.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterString.write(value.error, buf)


class DocImportProgressAllDone:
    key: "bytes";

    @typing.no_type_check
    def __init__(self, key: "bytes"):
        self.key = key

    def __str__(self):
        return "DocImportProgressAllDone(key={})".format(self.key)

    def __eq__(self, other):
        if self.key != other.key:
            return False
        return True

class _UniffiConverterTypeDocImportProgressAllDone(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return DocImportProgressAllDone(
            key=_UniffiConverterBytes.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterBytes.write(value.key, buf)


class DocImportProgressFound:
    id: "int";name: "str";size: "int";

    @typing.no_type_check
    def __init__(self, id: "int", name: "str", size: "int"):
        self.id = id
        self.name = name
        self.size = size

    def __str__(self):
        return "DocImportProgressFound(id={}, name={}, size={})".format(self.id, self.name, self.size)

    def __eq__(self, other):
        if self.id != other.id:
            return False
        if self.name != other.name:
            return False
        if self.size != other.size:
            return False
        return True

class _UniffiConverterTypeDocImportProgressFound(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return DocImportProgressFound(
            id=_UniffiConverterUInt64.read(buf),
            name=_UniffiConverterString.read(buf),
            size=_UniffiConverterUInt64.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterUInt64.write(value.id, buf)
        _UniffiConverterString.write(value.name, buf)
        _UniffiConverterUInt64.write(value.size, buf)


class DocImportProgressIngestDone:
    id: "int";hash: "Hash";

    @typing.no_type_check
    def __init__(self, id: "int", hash: "Hash"):
        self.id = id
        self.hash = hash

    def __str__(self):
        return "DocImportProgressIngestDone(id={}, hash={})".format(self.id, self.hash)

    def __eq__(self, other):
        if self.id != other.id:
            return False
        if self.hash != other.hash:
            return False
        return True

class _UniffiConverterTypeDocImportProgressIngestDone(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return DocImportProgressIngestDone(
            id=_UniffiConverterUInt64.read(buf),
            hash=_UniffiConverterTypeHash.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterUInt64.write(value.id, buf)
        _UniffiConverterTypeHash.write(value.hash, buf)


class DocImportProgressProgress:
    id: "int";offset: "int";

    @typing.no_type_check
    def __init__(self, id: "int", offset: "int"):
        self.id = id
        self.offset = offset

    def __str__(self):
        return "DocImportProgressProgress(id={}, offset={})".format(self.id, self.offset)

    def __eq__(self, other):
        if self.id != other.id:
            return False
        if self.offset != other.offset:
            return False
        return True

class _UniffiConverterTypeDocImportProgressProgress(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return DocImportProgressProgress(
            id=_UniffiConverterUInt64.read(buf),
            offset=_UniffiConverterUInt64.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterUInt64.write(value.id, buf)
        _UniffiConverterUInt64.write(value.offset, buf)


class DownloadProgressAbort:
    error: "str";

    @typing.no_type_check
    def __init__(self, error: "str"):
        self.error = error

    def __str__(self):
        return "DownloadProgressAbort(error={})".format(self.error)

    def __eq__(self, other):
        if self.error != other.error:
            return False
        return True

class _UniffiConverterTypeDownloadProgressAbort(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return DownloadProgressAbort(
            error=_UniffiConverterString.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterString.write(value.error, buf)


class DownloadProgressDone:
    id: "int";

    @typing.no_type_check
    def __init__(self, id: "int"):
        self.id = id

    def __str__(self):
        return "DownloadProgressDone(id={})".format(self.id)

    def __eq__(self, other):
        if self.id != other.id:
            return False
        return True

class _UniffiConverterTypeDownloadProgressDone(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return DownloadProgressDone(
            id=_UniffiConverterUInt64.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterUInt64.write(value.id, buf)


class DownloadProgressExport:
    id: "int";hash: "Hash";size: "int";target: "str";

    @typing.no_type_check
    def __init__(self, id: "int", hash: "Hash", size: "int", target: "str"):
        self.id = id
        self.hash = hash
        self.size = size
        self.target = target

    def __str__(self):
        return "DownloadProgressExport(id={}, hash={}, size={}, target={})".format(self.id, self.hash, self.size, self.target)

    def __eq__(self, other):
        if self.id != other.id:
            return False
        if self.hash != other.hash:
            return False
        if self.size != other.size:
            return False
        if self.target != other.target:
            return False
        return True

class _UniffiConverterTypeDownloadProgressExport(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return DownloadProgressExport(
            id=_UniffiConverterUInt64.read(buf),
            hash=_UniffiConverterTypeHash.read(buf),
            size=_UniffiConverterUInt64.read(buf),
            target=_UniffiConverterString.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterUInt64.write(value.id, buf)
        _UniffiConverterTypeHash.write(value.hash, buf)
        _UniffiConverterUInt64.write(value.size, buf)
        _UniffiConverterString.write(value.target, buf)


class DownloadProgressExportProgress:
    id: "int";offset: "int";

    @typing.no_type_check
    def __init__(self, id: "int", offset: "int"):
        self.id = id
        self.offset = offset

    def __str__(self):
        return "DownloadProgressExportProgress(id={}, offset={})".format(self.id, self.offset)

    def __eq__(self, other):
        if self.id != other.id:
            return False
        if self.offset != other.offset:
            return False
        return True

class _UniffiConverterTypeDownloadProgressExportProgress(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return DownloadProgressExportProgress(
            id=_UniffiConverterUInt64.read(buf),
            offset=_UniffiConverterUInt64.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterUInt64.write(value.id, buf)
        _UniffiConverterUInt64.write(value.offset, buf)


class DownloadProgressFound:
    id: "int";child: "int";hash: "Hash";size: "int";

    @typing.no_type_check
    def __init__(self, id: "int", child: "int", hash: "Hash", size: "int"):
        self.id = id
        self.child = child
        self.hash = hash
        self.size = size

    def __str__(self):
        return "DownloadProgressFound(id={}, child={}, hash={}, size={})".format(self.id, self.child, self.hash, self.size)

    def __eq__(self, other):
        if self.id != other.id:
            return False
        if self.child != other.child:
            return False
        if self.hash != other.hash:
            return False
        if self.size != other.size:
            return False
        return True

class _UniffiConverterTypeDownloadProgressFound(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return DownloadProgressFound(
            id=_UniffiConverterUInt64.read(buf),
            child=_UniffiConverterUInt64.read(buf),
            hash=_UniffiConverterTypeHash.read(buf),
            size=_UniffiConverterUInt64.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterUInt64.write(value.id, buf)
        _UniffiConverterUInt64.write(value.child, buf)
        _UniffiConverterTypeHash.write(value.hash, buf)
        _UniffiConverterUInt64.write(value.size, buf)


class DownloadProgressFoundHashSeq:
    children: "int";hash: "Hash";

    @typing.no_type_check
    def __init__(self, children: "int", hash: "Hash"):
        self.children = children
        self.hash = hash

    def __str__(self):
        return "DownloadProgressFoundHashSeq(children={}, hash={})".format(self.children, self.hash)

    def __eq__(self, other):
        if self.children != other.children:
            return False
        if self.hash != other.hash:
            return False
        return True

class _UniffiConverterTypeDownloadProgressFoundHashSeq(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return DownloadProgressFoundHashSeq(
            children=_UniffiConverterUInt64.read(buf),
            hash=_UniffiConverterTypeHash.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterUInt64.write(value.children, buf)
        _UniffiConverterTypeHash.write(value.hash, buf)


class DownloadProgressNetworkDone:
    bytes_written: "int";bytes_read: "int";elapsed: "Duration";

    @typing.no_type_check
    def __init__(self, bytes_written: "int", bytes_read: "int", elapsed: "Duration"):
        self.bytes_written = bytes_written
        self.bytes_read = bytes_read
        self.elapsed = elapsed

    def __str__(self):
        return "DownloadProgressNetworkDone(bytes_written={}, bytes_read={}, elapsed={})".format(self.bytes_written, self.bytes_read, self.elapsed)

    def __eq__(self, other):
        if self.bytes_written != other.bytes_written:
            return False
        if self.bytes_read != other.bytes_read:
            return False
        if self.elapsed != other.elapsed:
            return False
        return True

class _UniffiConverterTypeDownloadProgressNetworkDone(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return DownloadProgressNetworkDone(
            bytes_written=_UniffiConverterUInt64.read(buf),
            bytes_read=_UniffiConverterUInt64.read(buf),
            elapsed=_UniffiConverterDuration.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterUInt64.write(value.bytes_written, buf)
        _UniffiConverterUInt64.write(value.bytes_read, buf)
        _UniffiConverterDuration.write(value.elapsed, buf)


class DownloadProgressProgress:
    id: "int";offset: "int";

    @typing.no_type_check
    def __init__(self, id: "int", offset: "int"):
        self.id = id
        self.offset = offset

    def __str__(self):
        return "DownloadProgressProgress(id={}, offset={})".format(self.id, self.offset)

    def __eq__(self, other):
        if self.id != other.id:
            return False
        if self.offset != other.offset:
            return False
        return True

class _UniffiConverterTypeDownloadProgressProgress(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return DownloadProgressProgress(
            id=_UniffiConverterUInt64.read(buf),
            offset=_UniffiConverterUInt64.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterUInt64.write(value.id, buf)
        _UniffiConverterUInt64.write(value.offset, buf)


class InsertRemoteEvent:
    _from: "PublicKey";entry: "Entry";content_status: "ContentStatus";

    @typing.no_type_check
    def __init__(self, _from: "PublicKey", entry: "Entry", content_status: "ContentStatus"):
        self._from = _from
        self.entry = entry
        self.content_status = content_status

    def __str__(self):
        return "InsertRemoteEvent(_from={}, entry={}, content_status={})".format(self._from, self.entry, self.content_status)

    def __eq__(self, other):
        if self._from != other._from:
            return False
        if self.entry != other.entry:
            return False
        if self.content_status != other.content_status:
            return False
        return True

class _UniffiConverterTypeInsertRemoteEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return InsertRemoteEvent(
            _from=_UniffiConverterTypePublicKey.read(buf),
            entry=_UniffiConverterTypeEntry.read(buf),
            content_status=_UniffiConverterTypeContentStatus.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterTypePublicKey.write(value._from, buf)
        _UniffiConverterTypeEntry.write(value.entry, buf)
        _UniffiConverterTypeContentStatus.write(value.content_status, buf)


class NamespaceAndCapability:
    namespace: "NamespaceId";capability: "CapabilityKind";

    @typing.no_type_check
    def __init__(self, namespace: "NamespaceId", capability: "CapabilityKind"):
        self.namespace = namespace
        self.capability = capability

    def __str__(self):
        return "NamespaceAndCapability(namespace={}, capability={})".format(self.namespace, self.capability)

    def __eq__(self, other):
        if self.namespace != other.namespace:
            return False
        if self.capability != other.capability:
            return False
        return True

class _UniffiConverterTypeNamespaceAndCapability(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return NamespaceAndCapability(
            namespace=_UniffiConverterTypeNamespaceId.read(buf),
            capability=_UniffiConverterTypeCapabilityKind.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterTypeNamespaceId.write(value.namespace, buf)
        _UniffiConverterTypeCapabilityKind.write(value.capability, buf)


class OpenState:
    sync: "bool";subscribers: "int";handles: "int";

    @typing.no_type_check
    def __init__(self, sync: "bool", subscribers: "int", handles: "int"):
        self.sync = sync
        self.subscribers = subscribers
        self.handles = handles

    def __str__(self):
        return "OpenState(sync={}, subscribers={}, handles={})".format(self.sync, self.subscribers, self.handles)

    def __eq__(self, other):
        if self.sync != other.sync:
            return False
        if self.subscribers != other.subscribers:
            return False
        if self.handles != other.handles:
            return False
        return True

class _UniffiConverterTypeOpenState(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return OpenState(
            sync=_UniffiConverterBool.read(buf),
            subscribers=_UniffiConverterUInt64.read(buf),
            handles=_UniffiConverterUInt64.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterBool.write(value.sync, buf)
        _UniffiConverterUInt64.write(value.subscribers, buf)
        _UniffiConverterUInt64.write(value.handles, buf)


class QueryOptions:
    sort_by: "SortBy";direction: "SortDirection";offset: "int";limit: "int";

    @typing.no_type_check
    def __init__(self, sort_by: "SortBy", direction: "SortDirection", offset: "int", limit: "int"):
        self.sort_by = sort_by
        self.direction = direction
        self.offset = offset
        self.limit = limit

    def __str__(self):
        return "QueryOptions(sort_by={}, direction={}, offset={}, limit={})".format(self.sort_by, self.direction, self.offset, self.limit)

    def __eq__(self, other):
        if self.sort_by != other.sort_by:
            return False
        if self.direction != other.direction:
            return False
        if self.offset != other.offset:
            return False
        if self.limit != other.limit:
            return False
        return True

class _UniffiConverterTypeQueryOptions(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return QueryOptions(
            sort_by=_UniffiConverterTypeSortBy.read(buf),
            direction=_UniffiConverterTypeSortDirection.read(buf),
            offset=_UniffiConverterUInt64.read(buf),
            limit=_UniffiConverterUInt64.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterTypeSortBy.write(value.sort_by, buf)
        _UniffiConverterTypeSortDirection.write(value.direction, buf)
        _UniffiConverterUInt64.write(value.offset, buf)
        _UniffiConverterUInt64.write(value.limit, buf)


class SyncEvent:
    peer: "PublicKey";origin: "Origin";started: "Timestamp";finished: "Timestamp";result: "typing.Optional[str]";

    @typing.no_type_check
    def __init__(self, peer: "PublicKey", origin: "Origin", started: "Timestamp", finished: "Timestamp", result: "typing.Optional[str]"):
        self.peer = peer
        self.origin = origin
        self.started = started
        self.finished = finished
        self.result = result

    def __str__(self):
        return "SyncEvent(peer={}, origin={}, started={}, finished={}, result={})".format(self.peer, self.origin, self.started, self.finished, self.result)

    def __eq__(self, other):
        if self.peer != other.peer:
            return False
        if self.origin != other.origin:
            return False
        if self.started != other.started:
            return False
        if self.finished != other.finished:
            return False
        if self.result != other.result:
            return False
        return True

class _UniffiConverterTypeSyncEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return SyncEvent(
            peer=_UniffiConverterTypePublicKey.read(buf),
            origin=_UniffiConverterTypeOrigin.read(buf),
            started=_UniffiConverterTimestamp.read(buf),
            finished=_UniffiConverterTimestamp.read(buf),
            result=_UniffiConverterOptionalString.read(buf),
        )

    @staticmethod
    def write(value, buf):
        _UniffiConverterTypePublicKey.write(value.peer, buf)
        _UniffiConverterTypeOrigin.write(value.origin, buf)
        _UniffiConverterTimestamp.write(value.started, buf)
        _UniffiConverterTimestamp.write(value.finished, buf)
        _UniffiConverterOptionalString.write(value.result, buf)





class AddProgressType(enum.Enum):
    FOUND = 1
    PROGRESS = 2
    DONE = 3
    ALL_DONE = 4
    ABORT = 5
    


class _UniffiConverterTypeAddProgressType(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        variant = buf.read_i32()
        if variant == 1:
            return AddProgressType.FOUND
        if variant == 2:
            return AddProgressType.PROGRESS
        if variant == 3:
            return AddProgressType.DONE
        if variant == 4:
            return AddProgressType.ALL_DONE
        if variant == 5:
            return AddProgressType.ABORT
        raise InternalError("Raw enum value doesn't match any cases")

    def write(value, buf):
        if value == AddProgressType.FOUND:
            buf.write_i32(1)
        if value == AddProgressType.PROGRESS:
            buf.write_i32(2)
        if value == AddProgressType.DONE:
            buf.write_i32(3)
        if value == AddProgressType.ALL_DONE:
            buf.write_i32(4)
        if value == AddProgressType.ABORT:
            buf.write_i32(5)






class BlobFormat(enum.Enum):
    RAW = 1
    HASH_SEQ = 2
    


class _UniffiConverterTypeBlobFormat(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        variant = buf.read_i32()
        if variant == 1:
            return BlobFormat.RAW
        if variant == 2:
            return BlobFormat.HASH_SEQ
        raise InternalError("Raw enum value doesn't match any cases")

    def write(value, buf):
        if value == BlobFormat.RAW:
            buf.write_i32(1)
        if value == BlobFormat.HASH_SEQ:
            buf.write_i32(2)






class CapabilityKind(enum.Enum):
    WRITE = 1
    READ = 2
    


class _UniffiConverterTypeCapabilityKind(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        variant = buf.read_i32()
        if variant == 1:
            return CapabilityKind.WRITE
        if variant == 2:
            return CapabilityKind.READ
        raise InternalError("Raw enum value doesn't match any cases")

    def write(value, buf):
        if value == CapabilityKind.WRITE:
            buf.write_i32(1)
        if value == CapabilityKind.READ:
            buf.write_i32(2)






class ConnectionType:
    def __init__(self):
        raise RuntimeError("ConnectionType cannot be instantiated directly")

    # Each enum variant is a nested class of the enum itself.
    class DIRECT:
        addr: "str";port: "int";

        @typing.no_type_check
        def __init__(self,addr: "str", port: "int"):
            
            self.addr = addr
            self.port = port
            

        def __str__(self):
            return "ConnectionType.DIRECT(addr={}, port={})".format(self.addr, self.port)

        def __eq__(self, other):
            if not other.is_direct():
                return False
            if self.addr != other.addr:
                return False
            if self.port != other.port:
                return False
            return True
    class RELAY:
        port: "int";

        @typing.no_type_check
        def __init__(self,port: "int"):
            
            self.port = port
            

        def __str__(self):
            return "ConnectionType.RELAY(port={})".format(self.port)

        def __eq__(self, other):
            if not other.is_relay():
                return False
            if self.port != other.port:
                return False
            return True
    class MIXED:
        addr: "str";port: "int";

        @typing.no_type_check
        def __init__(self,addr: "str", port: "int"):
            
            self.addr = addr
            self.port = port
            

        def __str__(self):
            return "ConnectionType.MIXED(addr={}, port={})".format(self.addr, self.port)

        def __eq__(self, other):
            if not other.is_mixed():
                return False
            if self.addr != other.addr:
                return False
            if self.port != other.port:
                return False
            return True
    class NONE:
        

        @typing.no_type_check
        def __init__(self,):
            
            pass
            

        def __str__(self):
            return "ConnectionType.NONE()".format()

        def __eq__(self, other):
            if not other.is_none():
                return False
            return True
    

    # For each variant, we have an `is_NAME` method for easily checking
    # whether an instance is that variant.
    def is_direct(self) -> bool:
        return isinstance(self, ConnectionType.DIRECT)
    def is_relay(self) -> bool:
        return isinstance(self, ConnectionType.RELAY)
    def is_mixed(self) -> bool:
        return isinstance(self, ConnectionType.MIXED)
    def is_none(self) -> bool:
        return isinstance(self, ConnectionType.NONE)
    

# Now, a little trick - we make each nested variant class be a subclass of the main
# enum class, so that method calls and instance checks etc will work intuitively.
# We might be able to do this a little more neatly with a metaclass, but this'll do.
ConnectionType.DIRECT = type("ConnectionType.DIRECT", (ConnectionType.DIRECT, ConnectionType,), {})  # type: ignore
ConnectionType.RELAY = type("ConnectionType.RELAY", (ConnectionType.RELAY, ConnectionType,), {})  # type: ignore
ConnectionType.MIXED = type("ConnectionType.MIXED", (ConnectionType.MIXED, ConnectionType,), {})  # type: ignore
ConnectionType.NONE = type("ConnectionType.NONE", (ConnectionType.NONE, ConnectionType,), {})  # type: ignore




class _UniffiConverterTypeConnectionType(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        variant = buf.read_i32()
        if variant == 1:
            return ConnectionType.DIRECT(
                _UniffiConverterString.read(buf),
                _UniffiConverterUInt16.read(buf),
            )
        if variant == 2:
            return ConnectionType.RELAY(
                _UniffiConverterUInt16.read(buf),
            )
        if variant == 3:
            return ConnectionType.MIXED(
                _UniffiConverterString.read(buf),
                _UniffiConverterUInt16.read(buf),
            )
        if variant == 4:
            return ConnectionType.NONE(
            )
        raise InternalError("Raw enum value doesn't match any cases")

    def write(value, buf):
        if value.is_direct():
            buf.write_i32(1)
            _UniffiConverterString.write(value.addr, buf)
            _UniffiConverterUInt16.write(value.port, buf)
        if value.is_relay():
            buf.write_i32(2)
            _UniffiConverterUInt16.write(value.port, buf)
        if value.is_mixed():
            buf.write_i32(3)
            _UniffiConverterString.write(value.addr, buf)
            _UniffiConverterUInt16.write(value.port, buf)
        if value.is_none():
            buf.write_i32(4)






class ContentStatus(enum.Enum):
    COMPLETE = 1
    INCOMPLETE = 2
    MISSING = 3
    


class _UniffiConverterTypeContentStatus(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        variant = buf.read_i32()
        if variant == 1:
            return ContentStatus.COMPLETE
        if variant == 2:
            return ContentStatus.INCOMPLETE
        if variant == 3:
            return ContentStatus.MISSING
        raise InternalError("Raw enum value doesn't match any cases")

    def write(value, buf):
        if value == ContentStatus.COMPLETE:
            buf.write_i32(1)
        if value == ContentStatus.INCOMPLETE:
            buf.write_i32(2)
        if value == ContentStatus.MISSING:
            buf.write_i32(3)






class DocExportProgressType(enum.Enum):
    FOUND = 1
    PROGRESS = 2
    ALL_DONE = 3
    ABORT = 4
    


class _UniffiConverterTypeDocExportProgressType(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        variant = buf.read_i32()
        if variant == 1:
            return DocExportProgressType.FOUND
        if variant == 2:
            return DocExportProgressType.PROGRESS
        if variant == 3:
            return DocExportProgressType.ALL_DONE
        if variant == 4:
            return DocExportProgressType.ABORT
        raise InternalError("Raw enum value doesn't match any cases")

    def write(value, buf):
        if value == DocExportProgressType.FOUND:
            buf.write_i32(1)
        if value == DocExportProgressType.PROGRESS:
            buf.write_i32(2)
        if value == DocExportProgressType.ALL_DONE:
            buf.write_i32(3)
        if value == DocExportProgressType.ABORT:
            buf.write_i32(4)






class DocImportProgressType(enum.Enum):
    FOUND = 1
    PROGRESS = 2
    INGEST_DONE = 3
    ALL_DONE = 4
    ABORT = 5
    


class _UniffiConverterTypeDocImportProgressType(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        variant = buf.read_i32()
        if variant == 1:
            return DocImportProgressType.FOUND
        if variant == 2:
            return DocImportProgressType.PROGRESS
        if variant == 3:
            return DocImportProgressType.INGEST_DONE
        if variant == 4:
            return DocImportProgressType.ALL_DONE
        if variant == 5:
            return DocImportProgressType.ABORT
        raise InternalError("Raw enum value doesn't match any cases")

    def write(value, buf):
        if value == DocImportProgressType.FOUND:
            buf.write_i32(1)
        if value == DocImportProgressType.PROGRESS:
            buf.write_i32(2)
        if value == DocImportProgressType.INGEST_DONE:
            buf.write_i32(3)
        if value == DocImportProgressType.ALL_DONE:
            buf.write_i32(4)
        if value == DocImportProgressType.ABORT:
            buf.write_i32(5)






class DownloadProgressType(enum.Enum):
    CONNECTED = 1
    FOUND = 2
    FOUND_HASH_SEQ = 3
    PROGRESS = 4
    DONE = 5
    NETWORK_DONE = 6
    EXPORT = 7
    EXPORT_PROGRESS = 8
    ALL_DONE = 9
    ABORT = 10
    


class _UniffiConverterTypeDownloadProgressType(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        variant = buf.read_i32()
        if variant == 1:
            return DownloadProgressType.CONNECTED
        if variant == 2:
            return DownloadProgressType.FOUND
        if variant == 3:
            return DownloadProgressType.FOUND_HASH_SEQ
        if variant == 4:
            return DownloadProgressType.PROGRESS
        if variant == 5:
            return DownloadProgressType.DONE
        if variant == 6:
            return DownloadProgressType.NETWORK_DONE
        if variant == 7:
            return DownloadProgressType.EXPORT
        if variant == 8:
            return DownloadProgressType.EXPORT_PROGRESS
        if variant == 9:
            return DownloadProgressType.ALL_DONE
        if variant == 10:
            return DownloadProgressType.ABORT
        raise InternalError("Raw enum value doesn't match any cases")

    def write(value, buf):
        if value == DownloadProgressType.CONNECTED:
            buf.write_i32(1)
        if value == DownloadProgressType.FOUND:
            buf.write_i32(2)
        if value == DownloadProgressType.FOUND_HASH_SEQ:
            buf.write_i32(3)
        if value == DownloadProgressType.PROGRESS:
            buf.write_i32(4)
        if value == DownloadProgressType.DONE:
            buf.write_i32(5)
        if value == DownloadProgressType.NETWORK_DONE:
            buf.write_i32(6)
        if value == DownloadProgressType.EXPORT:
            buf.write_i32(7)
        if value == DownloadProgressType.EXPORT_PROGRESS:
            buf.write_i32(8)
        if value == DownloadProgressType.ALL_DONE:
            buf.write_i32(9)
        if value == DownloadProgressType.ABORT:
            buf.write_i32(10)



# IrohError
# We want to define each variant as a nested class that's also a subclass,
# which is tricky in Python.  To accomplish this we're going to create each
# class separately, then manually add the child classes to the base class's
# __dict__.  All of this happens in dummy class to avoid polluting the module
# namespace.
class IrohError(Exception):
    pass

_UniffiTempIrohError = IrohError

class IrohError:  # type: ignore
    class Runtime(_UniffiTempIrohError):
        def __init__(self, description):
            super().__init__(", ".join([
                "description={!r}".format(description),
            ]))
            self.description = description
        def __repr__(self):
            return "IrohError.Runtime({})".format(str(self))
    _UniffiTempIrohError.Runtime = Runtime # type: ignore
    class NodeCreate(_UniffiTempIrohError):
        def __init__(self, description):
            super().__init__(", ".join([
                "description={!r}".format(description),
            ]))
            self.description = description
        def __repr__(self):
            return "IrohError.NodeCreate({})".format(str(self))
    _UniffiTempIrohError.NodeCreate = NodeCreate # type: ignore
    class Doc(_UniffiTempIrohError):
        def __init__(self, description):
            super().__init__(", ".join([
                "description={!r}".format(description),
            ]))
            self.description = description
        def __repr__(self):
            return "IrohError.Doc({})".format(str(self))
    _UniffiTempIrohError.Doc = Doc # type: ignore
    class Author(_UniffiTempIrohError):
        def __init__(self, description):
            super().__init__(", ".join([
                "description={!r}".format(description),
            ]))
            self.description = description
        def __repr__(self):
            return "IrohError.Author({})".format(str(self))
    _UniffiTempIrohError.Author = Author # type: ignore
    class Namespace(_UniffiTempIrohError):
        def __init__(self, description):
            super().__init__(", ".join([
                "description={!r}".format(description),
            ]))
            self.description = description
        def __repr__(self):
            return "IrohError.Namespace({})".format(str(self))
    _UniffiTempIrohError.Namespace = Namespace # type: ignore
    class DocTicket(_UniffiTempIrohError):
        def __init__(self, description):
            super().__init__(", ".join([
                "description={!r}".format(description),
            ]))
            self.description = description
        def __repr__(self):
            return "IrohError.DocTicket({})".format(str(self))
    _UniffiTempIrohError.DocTicket = DocTicket # type: ignore
    class Uniffi(_UniffiTempIrohError):
        def __init__(self, description):
            super().__init__(", ".join([
                "description={!r}".format(description),
            ]))
            self.description = description
        def __repr__(self):
            return "IrohError.Uniffi({})".format(str(self))
    _UniffiTempIrohError.Uniffi = Uniffi # type: ignore
    class Connection(_UniffiTempIrohError):
        def __init__(self, description):
            super().__init__(", ".join([
                "description={!r}".format(description),
            ]))
            self.description = description
        def __repr__(self):
            return "IrohError.Connection({})".format(str(self))
    _UniffiTempIrohError.Connection = Connection # type: ignore
    class Blobs(_UniffiTempIrohError):
        def __init__(self, description):
            super().__init__(", ".join([
                "description={!r}".format(description),
            ]))
            self.description = description
        def __repr__(self):
            return "IrohError.Blobs({})".format(str(self))
    _UniffiTempIrohError.Blobs = Blobs # type: ignore
    class Ipv4Addr(_UniffiTempIrohError):
        def __init__(self, description):
            super().__init__(", ".join([
                "description={!r}".format(description),
            ]))
            self.description = description
        def __repr__(self):
            return "IrohError.Ipv4Addr({})".format(str(self))
    _UniffiTempIrohError.Ipv4Addr = Ipv4Addr # type: ignore
    class Ipv6Addr(_UniffiTempIrohError):
        def __init__(self, description):
            super().__init__(", ".join([
                "description={!r}".format(description),
            ]))
            self.description = description
        def __repr__(self):
            return "IrohError.Ipv6Addr({})".format(str(self))
    _UniffiTempIrohError.Ipv6Addr = Ipv6Addr # type: ignore
    class SocketAddrV4(_UniffiTempIrohError):
        def __init__(self, description):
            super().__init__(", ".join([
                "description={!r}".format(description),
            ]))
            self.description = description
        def __repr__(self):
            return "IrohError.SocketAddrV4({})".format(str(self))
    _UniffiTempIrohError.SocketAddrV4 = SocketAddrV4 # type: ignore
    class SocketAddrV6(_UniffiTempIrohError):
        def __init__(self, description):
            super().__init__(", ".join([
                "description={!r}".format(description),
            ]))
            self.description = description
        def __repr__(self):
            return "IrohError.SocketAddrV6({})".format(str(self))
    _UniffiTempIrohError.SocketAddrV6 = SocketAddrV6 # type: ignore
    class PublicKey(_UniffiTempIrohError):
        def __init__(self, description):
            super().__init__(", ".join([
                "description={!r}".format(description),
            ]))
            self.description = description
        def __repr__(self):
            return "IrohError.PublicKey({})".format(str(self))
    _UniffiTempIrohError.PublicKey = PublicKey # type: ignore
    class NodeAddr(_UniffiTempIrohError):
        def __init__(self, description):
            super().__init__(", ".join([
                "description={!r}".format(description),
            ]))
            self.description = description
        def __repr__(self):
            return "IrohError.NodeAddr({})".format(str(self))
    _UniffiTempIrohError.NodeAddr = NodeAddr # type: ignore
    class Hash(_UniffiTempIrohError):
        def __init__(self, description):
            super().__init__(", ".join([
                "description={!r}".format(description),
            ]))
            self.description = description
        def __repr__(self):
            return "IrohError.Hash({})".format(str(self))
    _UniffiTempIrohError.Hash = Hash # type: ignore
    class RequestToken(_UniffiTempIrohError):
        def __init__(self, description):
            super().__init__(", ".join([
                "description={!r}".format(description),
            ]))
            self.description = description
        def __repr__(self):
            return "IrohError.RequestToken({})".format(str(self))
    _UniffiTempIrohError.RequestToken = RequestToken # type: ignore
    class FsUtil(_UniffiTempIrohError):
        def __init__(self, description):
            super().__init__(", ".join([
                "description={!r}".format(description),
            ]))
            self.description = description
        def __repr__(self):
            return "IrohError.FsUtil({})".format(str(self))
    _UniffiTempIrohError.FsUtil = FsUtil # type: ignore

IrohError = _UniffiTempIrohError # type: ignore
del _UniffiTempIrohError


class _UniffiConverterTypeIrohError(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        variant = buf.read_i32()
        if variant == 1:
            return IrohError.Runtime(
                description=_UniffiConverterString.read(buf),
            )
        if variant == 2:
            return IrohError.NodeCreate(
                description=_UniffiConverterString.read(buf),
            )
        if variant == 3:
            return IrohError.Doc(
                description=_UniffiConverterString.read(buf),
            )
        if variant == 4:
            return IrohError.Author(
                description=_UniffiConverterString.read(buf),
            )
        if variant == 5:
            return IrohError.Namespace(
                description=_UniffiConverterString.read(buf),
            )
        if variant == 6:
            return IrohError.DocTicket(
                description=_UniffiConverterString.read(buf),
            )
        if variant == 7:
            return IrohError.Uniffi(
                description=_UniffiConverterString.read(buf),
            )
        if variant == 8:
            return IrohError.Connection(
                description=_UniffiConverterString.read(buf),
            )
        if variant == 9:
            return IrohError.Blobs(
                description=_UniffiConverterString.read(buf),
            )
        if variant == 10:
            return IrohError.Ipv4Addr(
                description=_UniffiConverterString.read(buf),
            )
        if variant == 11:
            return IrohError.Ipv6Addr(
                description=_UniffiConverterString.read(buf),
            )
        if variant == 12:
            return IrohError.SocketAddrV4(
                description=_UniffiConverterString.read(buf),
            )
        if variant == 13:
            return IrohError.SocketAddrV6(
                description=_UniffiConverterString.read(buf),
            )
        if variant == 14:
            return IrohError.PublicKey(
                description=_UniffiConverterString.read(buf),
            )
        if variant == 15:
            return IrohError.NodeAddr(
                description=_UniffiConverterString.read(buf),
            )
        if variant == 16:
            return IrohError.Hash(
                description=_UniffiConverterString.read(buf),
            )
        if variant == 17:
            return IrohError.RequestToken(
                description=_UniffiConverterString.read(buf),
            )
        if variant == 18:
            return IrohError.FsUtil(
                description=_UniffiConverterString.read(buf),
            )
        raise InternalError("Raw enum value doesn't match any cases")

    @staticmethod
    def write(value, buf):
        if isinstance(value, IrohError.Runtime):
            buf.write_i32(1)
            _UniffiConverterString.write(value.description, buf)
        if isinstance(value, IrohError.NodeCreate):
            buf.write_i32(2)
            _UniffiConverterString.write(value.description, buf)
        if isinstance(value, IrohError.Doc):
            buf.write_i32(3)
            _UniffiConverterString.write(value.description, buf)
        if isinstance(value, IrohError.Author):
            buf.write_i32(4)
            _UniffiConverterString.write(value.description, buf)
        if isinstance(value, IrohError.Namespace):
            buf.write_i32(5)
            _UniffiConverterString.write(value.description, buf)
        if isinstance(value, IrohError.DocTicket):
            buf.write_i32(6)
            _UniffiConverterString.write(value.description, buf)
        if isinstance(value, IrohError.Uniffi):
            buf.write_i32(7)
            _UniffiConverterString.write(value.description, buf)
        if isinstance(value, IrohError.Connection):
            buf.write_i32(8)
            _UniffiConverterString.write(value.description, buf)
        if isinstance(value, IrohError.Blobs):
            buf.write_i32(9)
            _UniffiConverterString.write(value.description, buf)
        if isinstance(value, IrohError.Ipv4Addr):
            buf.write_i32(10)
            _UniffiConverterString.write(value.description, buf)
        if isinstance(value, IrohError.Ipv6Addr):
            buf.write_i32(11)
            _UniffiConverterString.write(value.description, buf)
        if isinstance(value, IrohError.SocketAddrV4):
            buf.write_i32(12)
            _UniffiConverterString.write(value.description, buf)
        if isinstance(value, IrohError.SocketAddrV6):
            buf.write_i32(13)
            _UniffiConverterString.write(value.description, buf)
        if isinstance(value, IrohError.PublicKey):
            buf.write_i32(14)
            _UniffiConverterString.write(value.description, buf)
        if isinstance(value, IrohError.NodeAddr):
            buf.write_i32(15)
            _UniffiConverterString.write(value.description, buf)
        if isinstance(value, IrohError.Hash):
            buf.write_i32(16)
            _UniffiConverterString.write(value.description, buf)
        if isinstance(value, IrohError.RequestToken):
            buf.write_i32(17)
            _UniffiConverterString.write(value.description, buf)
        if isinstance(value, IrohError.FsUtil):
            buf.write_i32(18)
            _UniffiConverterString.write(value.description, buf)





class LiveEventType(enum.Enum):
    INSERT_LOCAL = 1
    INSERT_REMOTE = 2
    CONTENT_READY = 3
    NEIGHBOR_UP = 4
    NEIGHBOR_DOWN = 5
    SYNC_FINISHED = 6
    


class _UniffiConverterTypeLiveEventType(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        variant = buf.read_i32()
        if variant == 1:
            return LiveEventType.INSERT_LOCAL
        if variant == 2:
            return LiveEventType.INSERT_REMOTE
        if variant == 3:
            return LiveEventType.CONTENT_READY
        if variant == 4:
            return LiveEventType.NEIGHBOR_UP
        if variant == 5:
            return LiveEventType.NEIGHBOR_DOWN
        if variant == 6:
            return LiveEventType.SYNC_FINISHED
        raise InternalError("Raw enum value doesn't match any cases")

    def write(value, buf):
        if value == LiveEventType.INSERT_LOCAL:
            buf.write_i32(1)
        if value == LiveEventType.INSERT_REMOTE:
            buf.write_i32(2)
        if value == LiveEventType.CONTENT_READY:
            buf.write_i32(3)
        if value == LiveEventType.NEIGHBOR_UP:
            buf.write_i32(4)
        if value == LiveEventType.NEIGHBOR_DOWN:
            buf.write_i32(5)
        if value == LiveEventType.SYNC_FINISHED:
            buf.write_i32(6)






class LogLevel(enum.Enum):
    TRACE = 1
    DEBUG = 2
    INFO = 3
    WARN = 4
    ERROR = 5
    OFF = 6
    


class _UniffiConverterTypeLogLevel(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        variant = buf.read_i32()
        if variant == 1:
            return LogLevel.TRACE
        if variant == 2:
            return LogLevel.DEBUG
        if variant == 3:
            return LogLevel.INFO
        if variant == 4:
            return LogLevel.WARN
        if variant == 5:
            return LogLevel.ERROR
        if variant == 6:
            return LogLevel.OFF
        raise InternalError("Raw enum value doesn't match any cases")

    def write(value, buf):
        if value == LogLevel.TRACE:
            buf.write_i32(1)
        if value == LogLevel.DEBUG:
            buf.write_i32(2)
        if value == LogLevel.INFO:
            buf.write_i32(3)
        if value == LogLevel.WARN:
            buf.write_i32(4)
        if value == LogLevel.ERROR:
            buf.write_i32(5)
        if value == LogLevel.OFF:
            buf.write_i32(6)






class Origin:
    def __init__(self):
        raise RuntimeError("Origin cannot be instantiated directly")

    # Each enum variant is a nested class of the enum itself.
    class CONNECT:
        reason: "SyncReason";

        @typing.no_type_check
        def __init__(self,reason: "SyncReason"):
            
            self.reason = reason
            

        def __str__(self):
            return "Origin.CONNECT(reason={})".format(self.reason)

        def __eq__(self, other):
            if not other.is_connect():
                return False
            if self.reason != other.reason:
                return False
            return True
    class ACCEPT:
        

        @typing.no_type_check
        def __init__(self,):
            
            pass
            

        def __str__(self):
            return "Origin.ACCEPT()".format()

        def __eq__(self, other):
            if not other.is_accept():
                return False
            return True
    

    # For each variant, we have an `is_NAME` method for easily checking
    # whether an instance is that variant.
    def is_connect(self) -> bool:
        return isinstance(self, Origin.CONNECT)
    def is_accept(self) -> bool:
        return isinstance(self, Origin.ACCEPT)
    

# Now, a little trick - we make each nested variant class be a subclass of the main
# enum class, so that method calls and instance checks etc will work intuitively.
# We might be able to do this a little more neatly with a metaclass, but this'll do.
Origin.CONNECT = type("Origin.CONNECT", (Origin.CONNECT, Origin,), {})  # type: ignore
Origin.ACCEPT = type("Origin.ACCEPT", (Origin.ACCEPT, Origin,), {})  # type: ignore




class _UniffiConverterTypeOrigin(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        variant = buf.read_i32()
        if variant == 1:
            return Origin.CONNECT(
                _UniffiConverterTypeSyncReason.read(buf),
            )
        if variant == 2:
            return Origin.ACCEPT(
            )
        raise InternalError("Raw enum value doesn't match any cases")

    def write(value, buf):
        if value.is_connect():
            buf.write_i32(1)
            _UniffiConverterTypeSyncReason.write(value.reason, buf)
        if value.is_accept():
            buf.write_i32(2)






class ShareMode(enum.Enum):
    READ = 1
    WRITE = 2
    


class _UniffiConverterTypeShareMode(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        variant = buf.read_i32()
        if variant == 1:
            return ShareMode.READ
        if variant == 2:
            return ShareMode.WRITE
        raise InternalError("Raw enum value doesn't match any cases")

    def write(value, buf):
        if value == ShareMode.READ:
            buf.write_i32(1)
        if value == ShareMode.WRITE:
            buf.write_i32(2)






class SocketAddrType(enum.Enum):
    V4 = 1
    V6 = 2
    


class _UniffiConverterTypeSocketAddrType(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        variant = buf.read_i32()
        if variant == 1:
            return SocketAddrType.V4
        if variant == 2:
            return SocketAddrType.V6
        raise InternalError("Raw enum value doesn't match any cases")

    def write(value, buf):
        if value == SocketAddrType.V4:
            buf.write_i32(1)
        if value == SocketAddrType.V6:
            buf.write_i32(2)






class SortBy(enum.Enum):
    KEY_AUTHOR = 1
    AUTHOR_KEY = 2
    


class _UniffiConverterTypeSortBy(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        variant = buf.read_i32()
        if variant == 1:
            return SortBy.KEY_AUTHOR
        if variant == 2:
            return SortBy.AUTHOR_KEY
        raise InternalError("Raw enum value doesn't match any cases")

    def write(value, buf):
        if value == SortBy.KEY_AUTHOR:
            buf.write_i32(1)
        if value == SortBy.AUTHOR_KEY:
            buf.write_i32(2)






class SortDirection(enum.Enum):
    ASC = 1
    DESC = 2
    


class _UniffiConverterTypeSortDirection(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        variant = buf.read_i32()
        if variant == 1:
            return SortDirection.ASC
        if variant == 2:
            return SortDirection.DESC
        raise InternalError("Raw enum value doesn't match any cases")

    def write(value, buf):
        if value == SortDirection.ASC:
            buf.write_i32(1)
        if value == SortDirection.DESC:
            buf.write_i32(2)






class SyncReason(enum.Enum):
    DIRECT_JOIN = 1
    NEW_NEIGHBOR = 2
    SYNC_REPORT = 3
    RESYNC = 4
    


class _UniffiConverterTypeSyncReason(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        variant = buf.read_i32()
        if variant == 1:
            return SyncReason.DIRECT_JOIN
        if variant == 2:
            return SyncReason.NEW_NEIGHBOR
        if variant == 3:
            return SyncReason.SYNC_REPORT
        if variant == 4:
            return SyncReason.RESYNC
        raise InternalError("Raw enum value doesn't match any cases")

    def write(value, buf):
        if value == SyncReason.DIRECT_JOIN:
            buf.write_i32(1)
        if value == SyncReason.NEW_NEIGHBOR:
            buf.write_i32(2)
        if value == SyncReason.SYNC_REPORT:
            buf.write_i32(3)
        if value == SyncReason.RESYNC:
            buf.write_i32(4)




import threading

class ConcurrentHandleMap:
    """
    A map where inserting, getting and removing data is synchronized with a lock.
    """

    def __init__(self):
        # type Handle = int
        self._left_map = {}  # type: Dict[Handle, Any]
        self._right_map = {}  # type: Dict[Any, Handle]

        self._lock = threading.Lock()
        self._current_handle = 0
        self._stride = 1


    def insert(self, obj):
        with self._lock:
            if obj in self._right_map:
                return self._right_map[obj]
            else:
                handle = self._current_handle
                self._current_handle += self._stride
                self._left_map[handle] = obj
                self._right_map[obj] = handle
                return handle

    def get(self, handle):
        with self._lock:
            return self._left_map.get(handle)

    def remove(self, handle):
        with self._lock:
            if handle in self._left_map:
                obj = self._left_map.pop(handle)
                del self._right_map[obj]
                return obj

# Magic number for the Rust proxy to call using the same mechanism as every other method,
# to free the callback once it's dropped by Rust.
IDX_CALLBACK_FREE = 0
# Return codes for callback calls
_UNIFFI_CALLBACK_SUCCESS = 0
_UNIFFI_CALLBACK_ERROR = 1
_UNIFFI_CALLBACK_UNEXPECTED_ERROR = 2

class _UniffiConverterCallbackInterface:
    _handle_map = ConcurrentHandleMap()

    def __init__(self, cb):
        self._foreign_callback = cb

    def drop(self, handle):
        self.__class__._handle_map.remove(handle)

    @classmethod
    def lift(cls, handle):
        obj = cls._handle_map.get(handle)
        if not obj:
            raise InternalError("The object in the handle map has been dropped already")

        return obj

    @classmethod
    def read(cls, buf):
        handle = buf.read_u64()
        cls.lift(handle)

    @classmethod
    def lower(cls, cb):
        handle = cls._handle_map.insert(cb)
        return handle

    @classmethod
    def write(cls, cb, buf):
        buf.write_u64(cls.lower(cb))

# Declaration and _UniffiConverters for AddCallback Callback Interface

class AddCallback:
    def progress(self, progress: "AddProgress"):
        raise NotImplementedError

    

def py_foreignCallbackCallbackInterfaceAddCallback(handle, method, args_data, args_len, buf_ptr):
    
    def invoke_progress(python_callback, args_stream, buf_ptr):
        def makeCall():return python_callback.progress(
                _UniffiConverterTypeAddProgress.read(args_stream)
                )

        def makeCallAndHandleReturn():
            makeCall()
            return _UNIFFI_CALLBACK_SUCCESS
        try:
            return makeCallAndHandleReturn()
        except IrohError as e:
            # Catch errors declared in the UDL file
            with _UniffiRustBuffer.alloc_with_builder() as builder:
                _UniffiConverterTypeIrohError.write(e, builder)
                buf_ptr[0] = builder.finalize()
            return _UNIFFI_CALLBACK_ERROR

    

    cb = _UniffiConverterCallbackInterfaceAddCallback.lift(handle)
    if not cb:
        raise InternalError("No callback in handlemap; this is a uniffi bug")

    if method == IDX_CALLBACK_FREE:
        _UniffiConverterCallbackInterfaceAddCallback.drop(handle)
        # Successfull return
        # See docs of ForeignCallback in `uniffi_core/src/ffi/foreigncallbacks.rs`
        return _UNIFFI_CALLBACK_SUCCESS

    if method == 1:
        # Call the method and handle any errors
        # See docs of ForeignCallback in `uniffi_core/src/ffi/foreigncallbacks.rs` for details
        try:
            return invoke_progress(cb, _UniffiRustBufferStream(args_data, args_len), buf_ptr)
        except BaseException as e:
            # Catch unexpected errors
            try:
                # Try to serialize the exception into a String
                buf_ptr[0] = _UniffiConverterString.lower(repr(e))
            except:
                # If that fails, just give up
                pass
            return _UNIFFI_CALLBACK_UNEXPECTED_ERROR
    

    # This should never happen, because an out of bounds method index won't
    # ever be used. Once we can catch errors, we should return an InternalException.
    # https://github.com/mozilla/uniffi-rs/issues/351

    # An unexpected error happened.
    # See docs of ForeignCallback in `uniffi_core/src/ffi/foreigncallbacks.rs`
    return _UNIFFI_CALLBACK_UNEXPECTED_ERROR

# We need to keep this function reference alive:
# if they get GC'd while in use then UniFFI internals could attempt to call a function
# that is in freed memory.
# That would be...uh...bad. Yeah, that's the word. Bad.
foreignCallbackCallbackInterfaceAddCallback = _UNIFFI_FOREIGN_CALLBACK_T(py_foreignCallbackCallbackInterfaceAddCallback)
_rust_call(lambda err: _UniffiLib.uniffi_iroh_fn_init_callback_addcallback(foreignCallbackCallbackInterfaceAddCallback, err))

# The _UniffiConverter which transforms the Callbacks in to Handles to pass to Rust.
_UniffiConverterCallbackInterfaceAddCallback = _UniffiConverterCallbackInterface(foreignCallbackCallbackInterfaceAddCallback)





# Declaration and _UniffiConverters for DocExportFileCallback Callback Interface

class DocExportFileCallback:
    def progress(self, progress: "DocExportProgress"):
        raise NotImplementedError

    

def py_foreignCallbackCallbackInterfaceDocExportFileCallback(handle, method, args_data, args_len, buf_ptr):
    
    def invoke_progress(python_callback, args_stream, buf_ptr):
        def makeCall():return python_callback.progress(
                _UniffiConverterTypeDocExportProgress.read(args_stream)
                )

        def makeCallAndHandleReturn():
            makeCall()
            return _UNIFFI_CALLBACK_SUCCESS
        try:
            return makeCallAndHandleReturn()
        except IrohError as e:
            # Catch errors declared in the UDL file
            with _UniffiRustBuffer.alloc_with_builder() as builder:
                _UniffiConverterTypeIrohError.write(e, builder)
                buf_ptr[0] = builder.finalize()
            return _UNIFFI_CALLBACK_ERROR

    

    cb = _UniffiConverterCallbackInterfaceDocExportFileCallback.lift(handle)
    if not cb:
        raise InternalError("No callback in handlemap; this is a uniffi bug")

    if method == IDX_CALLBACK_FREE:
        _UniffiConverterCallbackInterfaceDocExportFileCallback.drop(handle)
        # Successfull return
        # See docs of ForeignCallback in `uniffi_core/src/ffi/foreigncallbacks.rs`
        return _UNIFFI_CALLBACK_SUCCESS

    if method == 1:
        # Call the method and handle any errors
        # See docs of ForeignCallback in `uniffi_core/src/ffi/foreigncallbacks.rs` for details
        try:
            return invoke_progress(cb, _UniffiRustBufferStream(args_data, args_len), buf_ptr)
        except BaseException as e:
            # Catch unexpected errors
            try:
                # Try to serialize the exception into a String
                buf_ptr[0] = _UniffiConverterString.lower(repr(e))
            except:
                # If that fails, just give up
                pass
            return _UNIFFI_CALLBACK_UNEXPECTED_ERROR
    

    # This should never happen, because an out of bounds method index won't
    # ever be used. Once we can catch errors, we should return an InternalException.
    # https://github.com/mozilla/uniffi-rs/issues/351

    # An unexpected error happened.
    # See docs of ForeignCallback in `uniffi_core/src/ffi/foreigncallbacks.rs`
    return _UNIFFI_CALLBACK_UNEXPECTED_ERROR

# We need to keep this function reference alive:
# if they get GC'd while in use then UniFFI internals could attempt to call a function
# that is in freed memory.
# That would be...uh...bad. Yeah, that's the word. Bad.
foreignCallbackCallbackInterfaceDocExportFileCallback = _UNIFFI_FOREIGN_CALLBACK_T(py_foreignCallbackCallbackInterfaceDocExportFileCallback)
_rust_call(lambda err: _UniffiLib.uniffi_iroh_fn_init_callback_docexportfilecallback(foreignCallbackCallbackInterfaceDocExportFileCallback, err))

# The _UniffiConverter which transforms the Callbacks in to Handles to pass to Rust.
_UniffiConverterCallbackInterfaceDocExportFileCallback = _UniffiConverterCallbackInterface(foreignCallbackCallbackInterfaceDocExportFileCallback)





# Declaration and _UniffiConverters for DocImportFileCallback Callback Interface

class DocImportFileCallback:
    def progress(self, progress: "DocImportProgress"):
        raise NotImplementedError

    

def py_foreignCallbackCallbackInterfaceDocImportFileCallback(handle, method, args_data, args_len, buf_ptr):
    
    def invoke_progress(python_callback, args_stream, buf_ptr):
        def makeCall():return python_callback.progress(
                _UniffiConverterTypeDocImportProgress.read(args_stream)
                )

        def makeCallAndHandleReturn():
            makeCall()
            return _UNIFFI_CALLBACK_SUCCESS
        try:
            return makeCallAndHandleReturn()
        except IrohError as e:
            # Catch errors declared in the UDL file
            with _UniffiRustBuffer.alloc_with_builder() as builder:
                _UniffiConverterTypeIrohError.write(e, builder)
                buf_ptr[0] = builder.finalize()
            return _UNIFFI_CALLBACK_ERROR

    

    cb = _UniffiConverterCallbackInterfaceDocImportFileCallback.lift(handle)
    if not cb:
        raise InternalError("No callback in handlemap; this is a uniffi bug")

    if method == IDX_CALLBACK_FREE:
        _UniffiConverterCallbackInterfaceDocImportFileCallback.drop(handle)
        # Successfull return
        # See docs of ForeignCallback in `uniffi_core/src/ffi/foreigncallbacks.rs`
        return _UNIFFI_CALLBACK_SUCCESS

    if method == 1:
        # Call the method and handle any errors
        # See docs of ForeignCallback in `uniffi_core/src/ffi/foreigncallbacks.rs` for details
        try:
            return invoke_progress(cb, _UniffiRustBufferStream(args_data, args_len), buf_ptr)
        except BaseException as e:
            # Catch unexpected errors
            try:
                # Try to serialize the exception into a String
                buf_ptr[0] = _UniffiConverterString.lower(repr(e))
            except:
                # If that fails, just give up
                pass
            return _UNIFFI_CALLBACK_UNEXPECTED_ERROR
    

    # This should never happen, because an out of bounds method index won't
    # ever be used. Once we can catch errors, we should return an InternalException.
    # https://github.com/mozilla/uniffi-rs/issues/351

    # An unexpected error happened.
    # See docs of ForeignCallback in `uniffi_core/src/ffi/foreigncallbacks.rs`
    return _UNIFFI_CALLBACK_UNEXPECTED_ERROR

# We need to keep this function reference alive:
# if they get GC'd while in use then UniFFI internals could attempt to call a function
# that is in freed memory.
# That would be...uh...bad. Yeah, that's the word. Bad.
foreignCallbackCallbackInterfaceDocImportFileCallback = _UNIFFI_FOREIGN_CALLBACK_T(py_foreignCallbackCallbackInterfaceDocImportFileCallback)
_rust_call(lambda err: _UniffiLib.uniffi_iroh_fn_init_callback_docimportfilecallback(foreignCallbackCallbackInterfaceDocImportFileCallback, err))

# The _UniffiConverter which transforms the Callbacks in to Handles to pass to Rust.
_UniffiConverterCallbackInterfaceDocImportFileCallback = _UniffiConverterCallbackInterface(foreignCallbackCallbackInterfaceDocImportFileCallback)





# Declaration and _UniffiConverters for DownloadCallback Callback Interface

class DownloadCallback:
    def progress(self, progress: "DownloadProgress"):
        raise NotImplementedError

    

def py_foreignCallbackCallbackInterfaceDownloadCallback(handle, method, args_data, args_len, buf_ptr):
    
    def invoke_progress(python_callback, args_stream, buf_ptr):
        def makeCall():return python_callback.progress(
                _UniffiConverterTypeDownloadProgress.read(args_stream)
                )

        def makeCallAndHandleReturn():
            makeCall()
            return _UNIFFI_CALLBACK_SUCCESS
        try:
            return makeCallAndHandleReturn()
        except IrohError as e:
            # Catch errors declared in the UDL file
            with _UniffiRustBuffer.alloc_with_builder() as builder:
                _UniffiConverterTypeIrohError.write(e, builder)
                buf_ptr[0] = builder.finalize()
            return _UNIFFI_CALLBACK_ERROR

    

    cb = _UniffiConverterCallbackInterfaceDownloadCallback.lift(handle)
    if not cb:
        raise InternalError("No callback in handlemap; this is a uniffi bug")

    if method == IDX_CALLBACK_FREE:
        _UniffiConverterCallbackInterfaceDownloadCallback.drop(handle)
        # Successfull return
        # See docs of ForeignCallback in `uniffi_core/src/ffi/foreigncallbacks.rs`
        return _UNIFFI_CALLBACK_SUCCESS

    if method == 1:
        # Call the method and handle any errors
        # See docs of ForeignCallback in `uniffi_core/src/ffi/foreigncallbacks.rs` for details
        try:
            return invoke_progress(cb, _UniffiRustBufferStream(args_data, args_len), buf_ptr)
        except BaseException as e:
            # Catch unexpected errors
            try:
                # Try to serialize the exception into a String
                buf_ptr[0] = _UniffiConverterString.lower(repr(e))
            except:
                # If that fails, just give up
                pass
            return _UNIFFI_CALLBACK_UNEXPECTED_ERROR
    

    # This should never happen, because an out of bounds method index won't
    # ever be used. Once we can catch errors, we should return an InternalException.
    # https://github.com/mozilla/uniffi-rs/issues/351

    # An unexpected error happened.
    # See docs of ForeignCallback in `uniffi_core/src/ffi/foreigncallbacks.rs`
    return _UNIFFI_CALLBACK_UNEXPECTED_ERROR

# We need to keep this function reference alive:
# if they get GC'd while in use then UniFFI internals could attempt to call a function
# that is in freed memory.
# That would be...uh...bad. Yeah, that's the word. Bad.
foreignCallbackCallbackInterfaceDownloadCallback = _UNIFFI_FOREIGN_CALLBACK_T(py_foreignCallbackCallbackInterfaceDownloadCallback)
_rust_call(lambda err: _UniffiLib.uniffi_iroh_fn_init_callback_downloadcallback(foreignCallbackCallbackInterfaceDownloadCallback, err))

# The _UniffiConverter which transforms the Callbacks in to Handles to pass to Rust.
_UniffiConverterCallbackInterfaceDownloadCallback = _UniffiConverterCallbackInterface(foreignCallbackCallbackInterfaceDownloadCallback)





# Declaration and _UniffiConverters for SubscribeCallback Callback Interface

class SubscribeCallback:
    def event(self, event: "LiveEvent"):
        raise NotImplementedError

    

def py_foreignCallbackCallbackInterfaceSubscribeCallback(handle, method, args_data, args_len, buf_ptr):
    
    def invoke_event(python_callback, args_stream, buf_ptr):
        def makeCall():return python_callback.event(
                _UniffiConverterTypeLiveEvent.read(args_stream)
                )

        def makeCallAndHandleReturn():
            makeCall()
            return _UNIFFI_CALLBACK_SUCCESS
        try:
            return makeCallAndHandleReturn()
        except IrohError as e:
            # Catch errors declared in the UDL file
            with _UniffiRustBuffer.alloc_with_builder() as builder:
                _UniffiConverterTypeIrohError.write(e, builder)
                buf_ptr[0] = builder.finalize()
            return _UNIFFI_CALLBACK_ERROR

    

    cb = _UniffiConverterCallbackInterfaceSubscribeCallback.lift(handle)
    if not cb:
        raise InternalError("No callback in handlemap; this is a uniffi bug")

    if method == IDX_CALLBACK_FREE:
        _UniffiConverterCallbackInterfaceSubscribeCallback.drop(handle)
        # Successfull return
        # See docs of ForeignCallback in `uniffi_core/src/ffi/foreigncallbacks.rs`
        return _UNIFFI_CALLBACK_SUCCESS

    if method == 1:
        # Call the method and handle any errors
        # See docs of ForeignCallback in `uniffi_core/src/ffi/foreigncallbacks.rs` for details
        try:
            return invoke_event(cb, _UniffiRustBufferStream(args_data, args_len), buf_ptr)
        except BaseException as e:
            # Catch unexpected errors
            try:
                # Try to serialize the exception into a String
                buf_ptr[0] = _UniffiConverterString.lower(repr(e))
            except:
                # If that fails, just give up
                pass
            return _UNIFFI_CALLBACK_UNEXPECTED_ERROR
    

    # This should never happen, because an out of bounds method index won't
    # ever be used. Once we can catch errors, we should return an InternalException.
    # https://github.com/mozilla/uniffi-rs/issues/351

    # An unexpected error happened.
    # See docs of ForeignCallback in `uniffi_core/src/ffi/foreigncallbacks.rs`
    return _UNIFFI_CALLBACK_UNEXPECTED_ERROR

# We need to keep this function reference alive:
# if they get GC'd while in use then UniFFI internals could attempt to call a function
# that is in freed memory.
# That would be...uh...bad. Yeah, that's the word. Bad.
foreignCallbackCallbackInterfaceSubscribeCallback = _UNIFFI_FOREIGN_CALLBACK_T(py_foreignCallbackCallbackInterfaceSubscribeCallback)
_rust_call(lambda err: _UniffiLib.uniffi_iroh_fn_init_callback_subscribecallback(foreignCallbackCallbackInterfaceSubscribeCallback, err))

# The _UniffiConverter which transforms the Callbacks in to Handles to pass to Rust.
_UniffiConverterCallbackInterfaceSubscribeCallback = _UniffiConverterCallbackInterface(foreignCallbackCallbackInterfaceSubscribeCallback)



class _UniffiConverterOptionalUInt16(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value, buf):
        if value is None:
            buf.write_u8(0)
            return

        buf.write_u8(1)
        _UniffiConverterUInt16.write(value, buf)

    @classmethod
    def read(cls, buf):
        flag = buf.read_u8()
        if flag == 0:
            return None
        elif flag == 1:
            return _UniffiConverterUInt16.read(buf)
        else:
            raise InternalError("Unexpected flag byte for optional type")



class _UniffiConverterOptionalUInt64(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value, buf):
        if value is None:
            buf.write_u8(0)
            return

        buf.write_u8(1)
        _UniffiConverterUInt64.write(value, buf)

    @classmethod
    def read(cls, buf):
        flag = buf.read_u8()
        if flag == 0:
            return None
        elif flag == 1:
            return _UniffiConverterUInt64.read(buf)
        else:
            raise InternalError("Unexpected flag byte for optional type")



class _UniffiConverterOptionalString(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value, buf):
        if value is None:
            buf.write_u8(0)
            return

        buf.write_u8(1)
        _UniffiConverterString.write(value, buf)

    @classmethod
    def read(cls, buf):
        flag = buf.read_u8()
        if flag == 0:
            return None
        elif flag == 1:
            return _UniffiConverterString.read(buf)
        else:
            raise InternalError("Unexpected flag byte for optional type")



class _UniffiConverterOptionalDuration(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value, buf):
        if value is None:
            buf.write_u8(0)
            return

        buf.write_u8(1)
        _UniffiConverterDuration.write(value, buf)

    @classmethod
    def read(cls, buf):
        flag = buf.read_u8()
        if flag == 0:
            return None
        elif flag == 1:
            return _UniffiConverterDuration.read(buf)
        else:
            raise InternalError("Unexpected flag byte for optional type")



class _UniffiConverterOptionalTypeEntry(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value, buf):
        if value is None:
            buf.write_u8(0)
            return

        buf.write_u8(1)
        _UniffiConverterTypeEntry.write(value, buf)

    @classmethod
    def read(cls, buf):
        flag = buf.read_u8()
        if flag == 0:
            return None
        elif flag == 1:
            return _UniffiConverterTypeEntry.read(buf)
        else:
            raise InternalError("Unexpected flag byte for optional type")



class _UniffiConverterOptionalTypeRequestToken(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value, buf):
        if value is None:
            buf.write_u8(0)
            return

        buf.write_u8(1)
        _UniffiConverterTypeRequestToken.write(value, buf)

    @classmethod
    def read(cls, buf):
        flag = buf.read_u8()
        if flag == 0:
            return None
        elif flag == 1:
            return _UniffiConverterTypeRequestToken.read(buf)
        else:
            raise InternalError("Unexpected flag byte for optional type")



class _UniffiConverterOptionalTypeConnectionInfo(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value, buf):
        if value is None:
            buf.write_u8(0)
            return

        buf.write_u8(1)
        _UniffiConverterTypeConnectionInfo.write(value, buf)

    @classmethod
    def read(cls, buf):
        flag = buf.read_u8()
        if flag == 0:
            return None
        elif flag == 1:
            return _UniffiConverterTypeConnectionInfo.read(buf)
        else:
            raise InternalError("Unexpected flag byte for optional type")



class _UniffiConverterOptionalTypeQueryOptions(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value, buf):
        if value is None:
            buf.write_u8(0)
            return

        buf.write_u8(1)
        _UniffiConverterTypeQueryOptions.write(value, buf)

    @classmethod
    def read(cls, buf):
        flag = buf.read_u8()
        if flag == 0:
            return None
        elif flag == 1:
            return _UniffiConverterTypeQueryOptions.read(buf)
        else:
            raise InternalError("Unexpected flag byte for optional type")



class _UniffiConverterOptionalCallbackInterfaceDocExportFileCallback(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value, buf):
        if value is None:
            buf.write_u8(0)
            return

        buf.write_u8(1)
        _UniffiConverterCallbackInterfaceDocExportFileCallback.write(value, buf)

    @classmethod
    def read(cls, buf):
        flag = buf.read_u8()
        if flag == 0:
            return None
        elif flag == 1:
            return _UniffiConverterCallbackInterfaceDocExportFileCallback.read(buf)
        else:
            raise InternalError("Unexpected flag byte for optional type")



class _UniffiConverterOptionalCallbackInterfaceDocImportFileCallback(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value, buf):
        if value is None:
            buf.write_u8(0)
            return

        buf.write_u8(1)
        _UniffiConverterCallbackInterfaceDocImportFileCallback.write(value, buf)

    @classmethod
    def read(cls, buf):
        flag = buf.read_u8()
        if flag == 0:
            return None
        elif flag == 1:
            return _UniffiConverterCallbackInterfaceDocImportFileCallback.read(buf)
        else:
            raise InternalError("Unexpected flag byte for optional type")



class _UniffiConverterSequenceUInt8(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value, buf):
        items = len(value)
        buf.write_i32(items)
        for item in value:
            _UniffiConverterUInt8.write(item, buf)

    @classmethod
    def read(cls, buf):
        count = buf.read_i32()
        if count < 0:
            raise InternalError("Unexpected negative sequence length")

        return [
            _UniffiConverterUInt8.read(buf) for i in range(count)
        ]



class _UniffiConverterSequenceUInt16(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value, buf):
        items = len(value)
        buf.write_i32(items)
        for item in value:
            _UniffiConverterUInt16.write(item, buf)

    @classmethod
    def read(cls, buf):
        count = buf.read_i32()
        if count < 0:
            raise InternalError("Unexpected negative sequence length")

        return [
            _UniffiConverterUInt16.read(buf) for i in range(count)
        ]



class _UniffiConverterSequenceTypeAuthorId(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value, buf):
        items = len(value)
        buf.write_i32(items)
        for item in value:
            _UniffiConverterTypeAuthorId.write(item, buf)

    @classmethod
    def read(cls, buf):
        count = buf.read_i32()
        if count < 0:
            raise InternalError("Unexpected negative sequence length")

        return [
            _UniffiConverterTypeAuthorId.read(buf) for i in range(count)
        ]



class _UniffiConverterSequenceTypeDirectAddrInfo(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value, buf):
        items = len(value)
        buf.write_i32(items)
        for item in value:
            _UniffiConverterTypeDirectAddrInfo.write(item, buf)

    @classmethod
    def read(cls, buf):
        count = buf.read_i32()
        if count < 0:
            raise InternalError("Unexpected negative sequence length")

        return [
            _UniffiConverterTypeDirectAddrInfo.read(buf) for i in range(count)
        ]



class _UniffiConverterSequenceTypeEntry(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value, buf):
        items = len(value)
        buf.write_i32(items)
        for item in value:
            _UniffiConverterTypeEntry.write(item, buf)

    @classmethod
    def read(cls, buf):
        count = buf.read_i32()
        if count < 0:
            raise InternalError("Unexpected negative sequence length")

        return [
            _UniffiConverterTypeEntry.read(buf) for i in range(count)
        ]



class _UniffiConverterSequenceTypeHash(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value, buf):
        items = len(value)
        buf.write_i32(items)
        for item in value:
            _UniffiConverterTypeHash.write(item, buf)

    @classmethod
    def read(cls, buf):
        count = buf.read_i32()
        if count < 0:
            raise InternalError("Unexpected negative sequence length")

        return [
            _UniffiConverterTypeHash.read(buf) for i in range(count)
        ]



class _UniffiConverterSequenceTypeNodeAddr(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value, buf):
        items = len(value)
        buf.write_i32(items)
        for item in value:
            _UniffiConverterTypeNodeAddr.write(item, buf)

    @classmethod
    def read(cls, buf):
        count = buf.read_i32()
        if count < 0:
            raise InternalError("Unexpected negative sequence length")

        return [
            _UniffiConverterTypeNodeAddr.read(buf) for i in range(count)
        ]



class _UniffiConverterSequenceTypeSocketAddr(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value, buf):
        items = len(value)
        buf.write_i32(items)
        for item in value:
            _UniffiConverterTypeSocketAddr.write(item, buf)

    @classmethod
    def read(cls, buf):
        count = buf.read_i32()
        if count < 0:
            raise InternalError("Unexpected negative sequence length")

        return [
            _UniffiConverterTypeSocketAddr.read(buf) for i in range(count)
        ]



class _UniffiConverterSequenceTypeBlobListCollectionsResponse(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value, buf):
        items = len(value)
        buf.write_i32(items)
        for item in value:
            _UniffiConverterTypeBlobListCollectionsResponse.write(item, buf)

    @classmethod
    def read(cls, buf):
        count = buf.read_i32()
        if count < 0:
            raise InternalError("Unexpected negative sequence length")

        return [
            _UniffiConverterTypeBlobListCollectionsResponse.read(buf) for i in range(count)
        ]



class _UniffiConverterSequenceTypeBlobListIncompleteResponse(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value, buf):
        items = len(value)
        buf.write_i32(items)
        for item in value:
            _UniffiConverterTypeBlobListIncompleteResponse.write(item, buf)

    @classmethod
    def read(cls, buf):
        count = buf.read_i32()
        if count < 0:
            raise InternalError("Unexpected negative sequence length")

        return [
            _UniffiConverterTypeBlobListIncompleteResponse.read(buf) for i in range(count)
        ]



class _UniffiConverterSequenceTypeConnectionInfo(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value, buf):
        items = len(value)
        buf.write_i32(items)
        for item in value:
            _UniffiConverterTypeConnectionInfo.write(item, buf)

    @classmethod
    def read(cls, buf):
        count = buf.read_i32()
        if count < 0:
            raise InternalError("Unexpected negative sequence length")

        return [
            _UniffiConverterTypeConnectionInfo.read(buf) for i in range(count)
        ]



class _UniffiConverterSequenceTypeNamespaceAndCapability(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value, buf):
        items = len(value)
        buf.write_i32(items)
        for item in value:
            _UniffiConverterTypeNamespaceAndCapability.write(item, buf)

    @classmethod
    def read(cls, buf):
        count = buf.read_i32()
        if count < 0:
            raise InternalError("Unexpected negative sequence length")

        return [
            _UniffiConverterTypeNamespaceAndCapability.read(buf) for i in range(count)
        ]



class _UniffiConverterMapStringTypeCounterStats(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, items, buf):
        buf.write_i32(len(items))
        for (key, value) in items.items():
            _UniffiConverterString.write(key, buf)
            _UniffiConverterTypeCounterStats.write(value, buf)

    @classmethod
    def read(cls, buf):
        count = buf.read_i32()
        if count < 0:
            raise InternalError("Unexpected negative map size")

        # It would be nice to use a dict comprehension,
        # but in Python 3.7 and before the evaluation order is not according to spec,
        # so we we're reading the value before the key.
        # This loop makes the order explicit: first reading the key, then the value.
        d = {}
        for i in range(count):
            key = _UniffiConverterString.read(buf)
            val = _UniffiConverterTypeCounterStats.read(buf)
            d[key] = val
        return d

def key_to_path(key: "bytes",prefix: "typing.Optional[str]",root: "typing.Optional[str]") -> "str":
    
    
    
    return _UniffiConverterString.lift(_rust_call_with_error(_UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_func_key_to_path,
        _UniffiConverterBytes.lower(key),
        _UniffiConverterOptionalString.lower(prefix),
        _UniffiConverterOptionalString.lower(root)))


def path_to_key(path: "str",prefix: "typing.Optional[str]",root: "typing.Optional[str]") -> "bytes":
    
    
    
    return _UniffiConverterBytes.lift(_rust_call_with_error(_UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_func_path_to_key,
        _UniffiConverterString.lower(path),
        _UniffiConverterOptionalString.lower(prefix),
        _UniffiConverterOptionalString.lower(root)))


def set_log_level(level: "LogLevel"):
    
    _rust_call(_UniffiLib.uniffi_iroh_fn_func_set_log_level,
        _UniffiConverterTypeLogLevel.lower(level))


def start_metrics_collection():
    _rust_call_with_error(_UniffiConverterTypeIrohError,_UniffiLib.uniffi_iroh_fn_func_start_metrics_collection,)


__all__ = [
    "InternalError",
    "AddProgressType",
    "BlobFormat",
    "CapabilityKind",
    "ConnectionType",
    "ContentStatus",
    "DocExportProgressType",
    "DocImportProgressType",
    "DownloadProgressType",
    "IrohError",
    "LiveEventType",
    "LogLevel",
    "Origin",
    "ShareMode",
    "SocketAddrType",
    "SortBy",
    "SortDirection",
    "SyncReason",
    "AddProgressAbort",
    "AddProgressAllDone",
    "AddProgressDone",
    "AddProgressFound",
    "AddProgressProgress",
    "BlobAddOutcome",
    "BlobListCollectionsResponse",
    "BlobListIncompleteResponse",
    "BlobListResponse",
    "ConnectionInfo",
    "CounterStats",
    "DocExportProgressAbort",
    "DocExportProgressFound",
    "DocExportProgressProgress",
    "DocImportProgressAbort",
    "DocImportProgressAllDone",
    "DocImportProgressFound",
    "DocImportProgressIngestDone",
    "DocImportProgressProgress",
    "DownloadProgressAbort",
    "DownloadProgressDone",
    "DownloadProgressExport",
    "DownloadProgressExportProgress",
    "DownloadProgressFound",
    "DownloadProgressFoundHashSeq",
    "DownloadProgressNetworkDone",
    "DownloadProgressProgress",
    "InsertRemoteEvent",
    "NamespaceAndCapability",
    "OpenState",
    "QueryOptions",
    "SyncEvent",
    "key_to_path",
    "path_to_key",
    "set_log_level",
    "start_metrics_collection",
    "AddProgress",
    "AuthorId",
    "BlobDownloadRequest",
    "DirectAddrInfo",
    "Doc",
    "DocExportProgress",
    "DocImportProgress",
    "DocTicket",
    "DownloadLocation",
    "DownloadProgress",
    "Entry",
    "Hash",
    "Ipv4Addr",
    "Ipv6Addr",
    "IrohNode",
    "LiveEvent",
    "NamespaceId",
    "NodeAddr",
    "PublicKey",
    "Query",
    "RequestToken",
    "SetTagOption",
    "SocketAddr",
    "SocketAddrV4",
    "SocketAddrV6",
    "Tag",
    "WrapOption",
    "AddCallback",
    "DocExportFileCallback",
    "DocImportFileCallback",
    "DownloadCallback",
    "SubscribeCallback",
]

